;Unit testing fake "ROM" for Emu8x
;
; Upon failure, executes ED FD opcode which is "call Debug" in Emu8x. Set a breakpoint on
; Debug to then trap errors.
;
 INCLUDE "equates.inc"
 	;res 00h
 	ld a,50h
	ret
	DB 0,0,0,0,0
	;res 08h
	ld a,58h
	ret
	DB 0,0,0,0,0
	;res 10h
	ld a,60h
	ret
	DB 0,0,0,0,0
	;res 18h
	ld a,68h
	ret
	DB 0,0,0,0,0
	;res 20h
	ld a,70h
	ret
	DB 0,0,0,0,0
	;res 28h
	ld a,78h
	ret
	DB 0,0,0,0,0
	;res 30h
	ld a,80h
	ret
	DB 0,0,0,0,0
	;res 38h
	ld a,88h
	ret
	;For the ROM detection routine
	ld a,16h
	out (4),a
	;Begin testing
	;
	;OPCODES:
	;ld r,r' (incomplete)
	;ld r,nn
	;cp nn
	;call nz,label
	;out (nn),a
	ld a,7
	out (10h),a
	ld a,80h
	out (10h),a
	ld a,20h
	out (10h),a
	ld a,1
	ld b,2
	ld c,3
	ld d,4
	ld e,5
	ld h,6
	ld l,7
	;ld a,r
	ld a,a
	cp 1
	call nz,Failure
	ld a,b
	cp 2
	call nz,Failure
	ld a,c
	cp 3
	call nz,Failure
	ld a,d
	cp 4
	call nz,Failure
	ld a,e
	cp 5
	call nz,Failure
	ld a,h
	cp 6
	call nz,Failure
	ld a,l
	cp 7
	call nz,Failure
	;ld hl,nnnn
	;ld (hl),nn
	;ld r,(hl)
	ld hl,scratch
	ld (hl),55
	ld a,(hl)
	cp 55
	call nz,Failure
	ld b,(hl)
	ld a,55
	cp b
	call nz,Failure
	ld c,(hl)
	cp c
	call nz,Failure
	ld d,(hl)
	cp d
	call nz,Failure
	ld e,(hl)
	cp e
	call nz,Failure
	ld h,(hl)
	cp h
	call nz,Failure
	ld hl,scratch
	ld l,(hl)
	cp l
	call nz,Failure
	;ld ix,nnnn
	;ld r,(ix+d)
	ld hl,ixtest-1
	ld (hl),99
	ld hl,ixtest+1
	ld (hl),101
	ld hl,ixtest
	ld (hl),100
	ld ix,ixtest
	ld a,(ix)
	cp 100
	call nz,Failure
	ld a,(ix-1)
	cp 99
	call nz,Failure
	ld a,(ix+1)
	cp 101
	call nz,Failure
	ld b,(ix-1)
	ld a,b
	cp 99
	call nz,Failure
	ld b,(ix)
	ld a,b
	cp 100
	call nz,Failure
	ld b,(ix+1)
	ld a,b
	cp 101
	call nz,Failure
	ld c,(ix-1)
	ld a,c
	cp 99
	call nz,Failure
	ld c,(ix)
	ld a,c
	cp 100
	call nz,Failure
	ld c,(ix+1)
	ld a,c
	cp 101
	call nz,Failure
	ld d,(ix-1)
	ld a,d
	cp 99
	call nz,Failure
	ld d,(ix)
	ld a,d
	cp 100
	call nz,Failure
	ld d,(ix+1)
	ld a,d
	cp 101
	call nz,Failure
	ld e,(ix-1)
	ld a,e
	cp 99
	call nz,Failure
	ld e,(ix)
	ld a,e
	cp 100
	call nz,Failure
	ld e,(ix+1)
	ld a,e
	cp 101
	call nz,Failure
	ld h,(ix-1)
	ld a,h
	cp 99
	call nz,Failure
	ld h,(ix)
	ld a,h
	cp 100
	call nz,Failure
	ld h,(ix+1)
	ld a,h
	cp 101
	call nz,Failure
	ld l,(ix-1)
	ld a,l
	cp 99
	call nz,Failure
	ld l,(ix)
	ld a,l
	cp 100
	call nz,Failure
	ld l,(ix+1)
	ld a,l
	cp 101
	call nz,Failure
	;ld r,(iy)
	;ld iy,nnnn
	ld iy,ixtest
	ld a,(iy)
	cp 100
	call nz,Failure
	ld a,(iy-1)
	cp 99
	call nz,Failure
	ld a,(iy+1)
	cp 101
	call nz,Failure
	ld b,(iy-1)
	ld a,b
	cp 99
	call nz,Failure
	ld b,(iy)
	ld a,b
	cp 100
	call nz,Failure
	ld b,(iy+1)
	ld a,b
	cp 101
	call nz,Failure
	ld c,(iy-1)
	ld a,c
	cp 99
	call nz,Failure
	ld c,(iy)
	ld a,c
	cp 100
	call nz,Failure
	ld c,(iy+1)
	ld a,c
	cp 101
	call nz,Failure
	ld d,(iy-1)
	ld a,d
	cp 99
	call nz,Failure
	ld d,(iy)
	ld a,d
	cp 100
	call nz,Failure
	ld d,(iy+1)
	ld a,d
	cp 101
	call nz,Failure
	ld e,(iy-1)
	ld a,e
	cp 99
	call nz,Failure
	ld e,(iy)
	ld a,e
	cp 100
	call nz,Failure
	ld e,(iy+1)
	ld a,e
	cp 101
	call nz,Failure
	ld h,(iy-1)
	ld a,h
	cp 99
	call nz,Failure
	ld h,(iy)
	ld a,h
	cp 100
	call nz,Failure
	ld h,(iy+1)
	ld a,h
	cp 101
	call nz,Failure
	ld l,(iy-1)
	ld a,l
	cp 99
	call nz,Failure
	ld l,(iy)
	ld a,l
	cp 100
	call nz,Failure
	ld l,(iy+1)
	ld a,l
	cp 101
	call nz,Failure
	;ld (hl),r
	;cp (hl)
	ld hl,scratch
	ld a,78
	ld (hl),a
	cp (hl)
	call nz,Failure
	ld b,79
	ld (hl),b
	ld a,b
	cp (hl)
	call nz,Failure
	ld c,80
	ld (hl),c
	ld a,c
	cp (hl)
	call nz,Failure
	ld d,81
	ld (hl),d
	ld a,d
	cp (hl)
	call nz,Failure
	ld e,82
	ld (hl),e
	ld a,e
	cp (hl)
	call nz,Failure
	ld h,83h
	ld (hl),h
	ld a,h
	cp (hl)
	call nz,Failure
	ld l,84h
	ld (hl),l
	ld a,l
	cp (hl)
	call nz,Failure
	;ld (ix+d),r
	;inc a
	ld ix,ixtest
	;
	ld a,112
	ld (ix-1),a
	inc a
	ld (ix),a
	inc a
	ld (ix+1),a
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	ld b,112
	ld (ix-1),b
	inc b
	ld (ix),b
	inc b
	ld (ix+1),b
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	ld c,112
	ld (ix-1),c
	inc c
	ld (ix),c
	inc c
	ld (ix+1),c
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	ld d,112
	ld (ix-1),d
	inc d
	ld (ix),d
	inc d
	ld (ix+1),d
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	ld e,112
	ld (ix-1),e
	inc e
	ld (ix),e
	inc e
	ld (ix+1),e
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	ld h,112
	ld (ix-1),h
	inc h
	ld (ix),h
	inc h
	ld (ix+1),h
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	ld l,112
	ld (ix-1),l
	inc l
	ld (ix),l
	inc l
	ld (ix+1),l
	ld a,(ix-1)
	cp 112
	call nz,Failure
	ld a,(ix)
	cp 113
	call nz,Failure
	ld a,(ix+1)
	cp 114
	call nz,Failure
	;ld (iy+d),r
	ld iy,ixtest
	;
	ld a,112
	ld (iy-1),a
	inc a
	ld (iy),a
	inc a
	ld (iy+1),a
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	ld b,112
	ld (iy-1),b
	inc b
	ld (iy),b
	inc b
	ld (iy+1),b
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	ld c,112
	ld (iy-1),c
	inc c
	ld (iy),c
	inc c
	ld (iy+1),c
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	ld d,112
	ld (iy-1),d
	inc d
	ld (iy),d
	inc d
	ld (iy+1),d
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	ld e,112
	ld (iy-1),e
	inc e
	ld (iy),e
	inc e
	ld (iy+1),e
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	ld h,112
	ld (iy-1),h
	inc h
	ld (iy),h
	inc h
	ld (iy+1),h
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	ld l,112
	ld (iy-1),l
	inc l
	ld (iy),l
	inc l
	ld (iy+1),l
	ld a,(iy-1)
	cp 112
	call nz,Failure
	ld a,(iy)
	cp 113
	call nz,Failure
	ld a,(iy+1)
	cp 114
	call nz,Failure
	;ld (ix+d),nn
	ld ix,ixtest
	ld (ix-1),23
	ld (ix),24
	ld (ix+1),25
	ld a,(ix-1)
	cp 23
	call nz,Failure
	ld a,(ix)
	cp 24
	call nz,Failure
	ld a,(ix+1)
	cp 25
	call nz,Failure
	;ld (iy+d),nn
	ld iy,ixtest
	ld (iy-1),23
	ld (iy),24
	ld (iy+1),25
	ld a,(iy-1)
	cp 23
	call nz,Failure
	ld a,(iy)
	cp 24
	call nz,Failure
	ld a,(iy+1)
	cp 25
	call nz,Failure
	;ld a,(bc)
	;ld bc,xxxx
	;ld de,xxxx
	;ld a,(de)
	;ld a,(nnnn)
	;ld (bc),a
	;ld (de),a
	;ld (nnnn),a
	ld hl,scratch
	ld (hl),109
	ld bc,scratch
	ld a,(bc)
	cp 109
	call nz,Failure
	ld de,scratch
	ld a,(de)
	cp 109
	call nz,Failure
	ld a,(scratch)
	cp 109
	call nz,Failure
	ld a,45
	ld (bc),a
	ld a,(scratch)
	cp 45
	call nz,Failure
	ld a,78
	ld (de),a
	ld a,(scratch)
	cp 78
	call nz,Failure
	ld a,87
	ld (scratch),a
	ld a,(scratch)
	cp 87
	call nz,Failure
	;ld a,i
	;ld i,a
	ld a,201
	ld i,a
	ld a,i
	call p,Failure
	ld a,0
	ld i,a
	ld a,i
	call nz,Failure
	;ld a,r
	;ld r,a
	ld a,r
	ld r,a
	;ld dd,nn
	ld a,234
	ld (ixtest),a
	ld bc,ixtest
	ld de,ixtest
	ld hl,ixtest
	ld a,(bc)
	cp 234
	call nz,Failure
	ld a,(de)
	cp 234
	call nz,Failure
	ld a,(hl)
	cp 234
	call nz,Failure
	ld sp,ixtest
	pop hl
	ld sp,0FFFFh
	ld a,l
	cp 234
	call nz,Failure
	;ld hl,(nnnn)
	ld ix,scratch
	ld (ix),91
	ld (ix+1),86
	ld hl,(scratch)
	ld a,l
	cp 91
	call nz,Failure
	ld a,h
	cp 86
	call nz,Failure
	;ld dd,(nnnn)
	ld bc,(scratch)
	ld a,c
	cp 91
	call nz,Failure
	ld a,b
	cp 86
	call nz,Failure
	ld de,(scratch)
	ld a,e
	cp 91
	call nz,Failure
	ld a,d
	cp 86
	call nz,Failure
	ld a,0
	ld (scratch),a
	ld a,90h
	ld (scratch+1),a
	ld a,32
	ld (9000h),a
	ld sp,(scratch)
	pop hl
	ld sp,0FFFFh
	ld a,l
	cp 32
	call nz,Failure
	;ld ix,(nnnn)
	;ld iy,(nnnn)
	ld ix,(scratch)
	ld a,(ix)
	cp 32
	call nz,Failure
	ld iy,(scratch)
	ld a,(iy)
	cp 32
	call nz,Failure
	;ld (nnnn),hl
	ld hl,58*256+82
	ld (scratch),hl
	ld a,(scratch)
	cp 82
	call nz,Failure
	ld a,(scratch+1)
	cp 58
	call nz,Failure
	;ld (nnnn),dd
	ld bc,42*256+2
	ld (scratch),bc
	ld a,(scratch)
	cp 2
	call nz,Failure
	ld a,(scratch+1)
	cp 42
	call nz,Failure
	ld de,34*256+27
	ld (scratch),de
	ld a,(scratch)
	cp 27
	call nz,Failure
	ld a,(scratch+1)
	cp 34
	call nz,Failure
	ld hl,56*256+67
	ld sp,0ffffh
	ld (scratch),sp
	ld a,(scratch)
	cp 255
	call nz,Failure
	ld a,(scratch+1)
	cp 255
	call nz,Failure
	;ld (nnnn),ix
	;ld (nnnn),iy
	ld ix,4*256+3
	ld (scratch),ix
	ld a,(scratch)
	cp 3
	call nz,Failure
	ld a,(scratch+1)
	cp 4
	call nz,Failure
	ld iy,5*256+6
	ld (scratch),iy
	ld a,(scratch)
	cp 6
	call nz,Failure
	ld a,(scratch+1)
	cp 5
	call nz,Failure
	;ld sp,hl
	ld hl,3487h
	ld sp,hl
	ld (scratch),sp
	ld sp,0ffffh
	ld a,(scratch)
	cp 87h
	call nz,Failure
	ld a,(scratch+1)
	cp 34h
	call nz,Failure
	;ld sp,ix
	ld ix,6927h
	ld sp,ix
	ld (scratch),sp
	ld sp,0ffffh
	ld a,(scratch)
	cp 27h
	call nz,Failure
	ld a,(scratch+1)
	cp 69h
	call nz,Failure
	;ld sp,iy
	ld iy,1237h
	ld sp,iy
	ld (scratch),sp
	ld sp,0ffffh
	ld a,(scratch)
	cp 37h
	call nz,Failure
	ld a,(scratch+1)
	cp 12h
	call nz,Failure
	;push qq
	;pop qq
	ld sp,0ffffh
	ld a,50
	push af
	ld a,(0fffeh)
	cp 50
	call nz,Failure
	ld a,2
	pop af
	cp 50
	call nz,Failure
	ld bc,3724h
	push bc
	ld a,(0fffeh)
	cp 37h
	call nz,Failure
	ld a,(0fffdh)
	cp 24h
	call nz,Failure
	ld bc,0
	pop bc
	ld a,c
	cp 24h
	call nz,Failure
	ld a,b
	cp 37h
	call nz,Failure
	ld de,2987h
	push de
	ld a,(0FFFDh)
	cp 87h
	call nz,Failure
	ld a,(0FFFEh)
	cp 29h
	call nz,Failure
	ld de,0
	pop de
	ld a,e
	cp 87h
	call nz,Failure
	ld a,d
	cp 29h
	call nz,Failure
	ld hl,0A24Bh
	push hl
	ld a,(0FFFDh)
	cp 4Bh
	call nz,Failure
	ld a,(0FFFEh)
	cp 0A2h
	call nz,Failure
	ld hl,0
	pop hl
	ld a,l
	cp 4Bh
	call nz,Failure
	ld a,h
	cp 0A2h
	call nz,Failure
	;push ix
	;push iy
	;pop iy
	;pop ix
	ld ix,89C4h
	push ix
	ld a,(0FFFDh)
	cp 0C4h
	call nz,Failure
	ld a,(0FFFEh)
	cp 89h
	call nz,Failure
	ld iy,921Ah
	push iy
	ld a,(0FFFBh)
	cp 1Ah
	call nz,Failure
	ld a,(0FFFCh)
	cp 92h
	call nz,Failure
	ld ix,0
	ld iy,0
	pop iy
	pop ix
	ld a,11
	ld (921Ah),a
	ld (89C4h),a
	ld a,(ix)
	cp 11
	call nz,Failure
	ld a,(iy)
	cp 11
	call nz,Failure
	;ex de,hl
	ld hl,3476h
	ld de,1234h
	ex de,hl
	ld a,l
	cp 34h
	call nz,Failure
	ld a,h
	cp 12h
	call nz,Failure
	ld a,e
	cp 76h
	call nz,Failure
	ld a,d
	cp 34h
	call nz,Failure
	;ex af,af'
	scf
	ld a,23
	ex af,af'
	ld a,42
	or a
	ex af,af'
	call nc,Failure
	cp 23
	call nz,Failure
	ex af,af'
	cp 42
	call c,Failure
	call nz,Failure
	ld bc,0101h
	ld de,0202h
	ld hl,0303h
	exx
	ld bc,0FFFFh
	ld de,0FEFEh
	ld hl,0FDFDh
	exx
	ld a,l
	cp 03h
	call nz,Failure
	ld a,h
	cp 3
	call nz,Failure
	ld a,e
	cp 2
	call nz,Failure
	ld a,d
	cp 2
	call nz,Failure
	ld a,c
	cp 1
	call nz,Failure
	ld a,b
	cp 1
	call nz,Failure
	exx
	ld a,l
	cp 0FDh
	call nz,Failure
	ld a,h
	cp 0FDh
	call nz,Failure
	ld a,e
	cp 0FEh
	call nz,Failure
	ld a,d
	cp 0FEh
	call nz,Failure
	ld a,c
	cp 0FFh
	call nz,Failure
	ld a,b
	cp 0FFh
	call nz,Failure
	;ex (sp),hl
	ld sp,0fff0h
	ld a,146
	ld (0fff0h),a
	ld a,203
	ld (0fff1h),a
	ld hl,34*256+99
	ex (sp),hl
	ld a,l
	cp 146
	call nz,Failure
	ld a,h
	cp 203
	call nz,Failure
	ld a,(0fff0h)
	cp 99
	call nz,Failure
	ld a,(0fff1h)
	cp 34
	call nz,Failure
	;ex (sp),ix
	ld sp,0fff0h
	ld a,83h
	ld (0fff1h),a
	ld a,20h
	ld (0fff0h),a
	ld ix,8045h
	ex (sp),ix
	ld a,23
	ld (8320h),a
	ld a,(ix)
	cp 23
	call nz,Failure
	ld a,(0fff1h)
	cp 80h
	call nz,Failure
	ld a,(0fff0h)
	cp 45h
	call nz,Failure
	;ex (sp),iy
	ld sp,0fff0h
	ld a,84h
	ld (0fff1h),a
	ld a,22h
	ld (0fff0h),a
	ld iy,8342h
	ex (sp),iy
	ld a,23
	ld (8422h),a
	ld a,(iy)
	cp 23
	call nz,Failure
	ld a,(0fff1h)
	cp 83h
	call nz,Failure
	ld a,(0fff0h)
	cp 42h
	call nz,Failure
	;ldi
	or a
	ld hl,testdata
	ld de,8208h
	ld bc,3
	ldi
	call po,Failure
	ld a,(8208h)
	cp 1
	call nz,Failure
	ld a,e
	cp 9
	call nz,Failure
	ld a,d
	cp 82h
	call nz,Failure
	ld a,c
	cp 2
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld hl,8208h
	ld de,8422h
	ld bc,1
	ldi
	call pe,Failure
	ld a,(8422h)
	cp 1
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,e
	cp 23h
	call nz,Failure
	ld a,d
	cp 84h
	call nz,Failure
	ld a,l
	cp 9h
	call nz,Failure
	ld a,h
	cp 82h
	call nz,Failure
	;ldd
	ld hl,testdata+1
	ld de,9022h
	ld bc,3
	ldd
	call po,Failure
	ld a,c
	cp 2
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,e
	cp 21h
	call nz,Failure
	ld a,d
	cp 90h
	call nz,Failure
	ld a,(9022h)
	cp 2
	call nz,Failure
	ld hl,9022h
	ld de,9000h
	ld bc,1
	ldd
	call pe,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,e
	cp 0FFh
	call nz,Failure
	ld a,d
	cp 8Fh
	call nz,Failure
	ld a,l
	cp 21h
	call nz,Failure
	ld a,h
	cp 90h
	call nz,Failure
	;ldir
	ld hl,testdata
	ld de,8111h
	ld bc,3
	ldir
	call pe,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,e
	cp 14h
	call nz,Failure
	ld a,d
	cp 81h
	call nz,Failure
	ld a,(8111h)
	cp 1
	call nz,Failure
	ld a,(8112h)
	cp 2
	call nz,Failure
	ld a,(8113h)
	cp 3
	call nz,Failure
	ld a,55
	ld (9A34h),a
	ld hl,8111h
	ld de,9A32h
	ld bc,2
	ldir
	call pe,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,l
	cp 13h
	call nz,Failure
	ld a,h
	cp 81h
	call nz,Failure
	ld a,e
	cp 34h
	call nz,Failure
	ld a,d
	cp 9Ah
	call nz,Failure
	ld a,(9A32h)
	cp 1
	call nz,Failure
	ld a,(9A33h)
	cp 2
	call nz,Failure
	ld a,(9A34h)
	cp 55
	call nz,Failure
	;lddr
	ld hl,testdata+2
	ld de,8111h
	ld bc,3
	lddr
	call pe,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,e
	cp 0Eh
	call nz,Failure
	ld a,d
	cp 81h
	call nz,Failure
	ld a,(8111h)
	cp 3
	call nz,Failure
	ld a,(8110h)
	cp 2
	call nz,Failure
	ld a,(810Fh)
	cp 1
	call nz,Failure
	ld a,55
	ld (9A36h),a
	ld hl,8111h
	ld de,9A38h
	ld bc,2
	lddr
	call pe,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld a,l
	cp 0Fh
	call nz,Failure
	ld a,h
	cp 81h
	call nz,Failure
	ld a,e
	cp 36h
	call nz,Failure
	ld a,d
	cp 9Ah
	call nz,Failure
	ld a,(9A38h)
	cp 3
	call nz,Failure
	ld a,(9A37h)
	cp 2
	call nz,Failure
	ld a,(9A36h)
	cp 55
	call nz,Failure
	;cpi
	ld hl,testdata
	ld a,0
	ld bc,1
	cpi
	call z,Failure
	cp 0
	call nz,Failure
	ld hl,testdata
	ld a,1
	ld bc,1
	cpi
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld hl,9000h
	ld a,45
	ld (hl),a
	ld bc,34
	cpi
	call nz,Failure
	ld a,l
	cp 1
	call nz,Failure
	ld a,h
	cp 90h
	call nz,Failure
	ld a,c
	cp 33
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	;cpd
	ld hl,testdata
	ld a,0
	ld bc,1
	cpd
	call z,Failure
	cp 0
	call nz,Failure
	ld hl,testdata
	ld a,1
	ld bc,1
	cpd
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld hl,9000h
	ld a,45
	ld (hl),a
	ld bc,34
	cpd
	call nz,Failure
	ld a,l
	cp 0FFh
	call nz,Failure
	ld a,h
	cp 8Fh
	call nz,Failure
	ld a,c
	cp 33
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	;cpir
	ld hl,testdata
	ld a,3
	ld bc,3
	cpir
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld hl,testdata
	ld de,9000h
	ld bc,3
	ldir
	ld hl,testdata
	ld a,3
	ld bc,3
	cpir
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	;cpdr
	ld hl,testdata+2
	ld a,1
	ld bc,3
	cpdr
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	ld hl,9002h
	ld bc,3
	ld a,1
	cpdr
	call nz,Failure
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 0
	call nz,Failure
	;add a,r
	ld a,34
	add a,a
	cp 68
	call nz,Failure
	ld a,129
	ld b,2
	ld c,4
	ld d,8
	ld e,16
	ld h,32
	ld l,64
	add a,b
	add a,c
	add a,d
	add a,e
	add a,h
	add a,l
	cp 255
	call nz,Failure
	add a,45
	call nc,Failure
	cp 44
	call nz,Failure
	ld a,22
	ld (scratch),a
	ld a,79
	ld hl,scratch
	add a,(hl)
	cp 101
	call nz,Failure
	ld ix,ixtest
	ld (ix-1),5
	ld (ix),10
	ld (ix+1),15
	ld a,2
	add a,(ix-1)
	cp 7
	call nz,Failure
	add a,(ix)
	cp 17
	call nz,Failure
	add a,(ix+1)
	cp 32
	call nz,Failure
	ld iy,ixtest
	add a,(iy-1)
	cp 37
	call nz,Failure
	add a,(iy)
	cp 47
	call nz,Failure
	add a,(iy+1)
	cp 62
	call nz,Failure
	;adc a,
	ld a,1
	scf
	adc a,1
   cp 3
	call nz,Failure
	ld b,3
	adc a,b
	cp 6
	call nz,Failure
	ld c,4
	ld d,3
	ld e,8
	ld h,16
	ld l,32
	adc a,c
	adc a,d
	adc a,e
	adc a,h
	adc a,l
	cp 69
	call nz,Failure
	ld hl,scratch
	ld (hl),3
	adc a,(hl)
	cp 72
	call nz,Failure
	ld ix,scratch
	ld iy,scratch
	adc a,(ix)
	adc a,(iy)
	cp 78
	call nz,Failure
	;sub
	sub (ix)
	sub (iy)
	cp 72
	call nz,Failure
	ld l,32
	ld h,16
	sub l
	sub h
	sub e
	sub d
	sub c
	cp 9
	call nz,Failure
	sub a
	call nz,Failure
	ld hl,scratch
	sub (hl)
	cp -3
	call nz,Failure
	;sbc
	scf
	ld a,2
	sbc a,a
	cp 255
	call nz,Failure
	ld a,72
	ld l,32
	ld h,16
	sbc a,b
	sbc a,c
	sbc a,d
	sbc a,e
	sbc a,h
	sbc a,l
	cp 6
	call nz,Failure
	ld hl,scratch
	sbc a,(hl)
	cp 3
	call nz,Failure
	sbc a,(ix)
	cp 0
	call nz,Failure
	sbc a,(iy)
	call nc,Failure
	cp -3
	call nz,Failure
	;and
	ld a,201
	and a
	cp 201
	call nz,Failure
	ld a,255
	ld b,10000001b
	ld c,01000001b
	ld d,00100001b
	ld e,00010001b
	ld h,00001001b
	ld l,00000101b
	and b
	and c
	and d
	and e
	and h
	and l
	cp 1
	call nz,Failure
	ld a,192
	ld hl,scratch
	ld (hl),128
	and (hl)
	cp 128
	call nz,Failure
	and (ix)
	and (iy)
	cp 128
	call nz,Failure
	ld (hl),0
	and (hl)
	call nz,Failure
	;or
	ld a,1
	ld b,2
	ld c,4
	ld d,8
	ld e,16
	ld h,32
	ld l,64
	or a
	call z,Failure
	or b
	or c
	or d
	or e
	or h
	or l
	cp 127
	call nz,Failure
	ld hl,scratch
	ld (hl),128
	or (hl)
	cp 255
	call nz,Failure
	ld a,63
	ld (hl),128
	or (ix)
	cp 191
	call nz,Failure
	ld (hl),64
	or (iy)
	cp 255
	call nz,Failure
	;xor
	xor a
	call nz,Failure
	ld a,201
	ld b,35
	ld c,35
	ld d,35
	ld e,35
	ld h,35
	ld l,35
	xor b
	xor c
	xor d
	xor e
	xor h
	xor l
	cp 201
	call nz,Failure
	ld hl,scratch
	ld (hl),201
	xor (hl)
	call nz,Failure
	xor (ix)
	call z,Failure
	xor (iy)
	call nz,Failure
	;cp
	ld a,4
	cp 5
	call nc,Failure
	ld b,4
	cp b
	call nz,Failure
	ld c,4
	cp c
	call nz,Failure
	ld d,4
	cp d
	call nz,Failure
	ld e,4
	cp e
	call nz,Failure
	ld h,4
	cp h
	call nz,Failure
	ld l,4
	cp l
	call nz,Failure
	ld a,1
	ld hl,testdata
	cp (hl)
	call nz,Failure
	ld ix,ixtest
	ld (ix),45
	ld iy,ixtest
	cp (ix)
	call z,Failure
	cp (iy)
	call nc,Failure
	;inc
	ld a,2
	inc a
	cp 3
	call nz,Failure
	ld b,a
	inc b
	ld c,b
	inc c
	ld d,c
	inc d
	ld e,d
	inc e
	ld h,e
	inc h
	ld l,h
	inc l
	ld a,l
	cp 9
	call nz,Failure
	ld hl,scratch
	ld (hl),23
	inc (hl)
	ld a,(hl)
	cp 24
	call nz,Failure
	inc (ix)
	inc (iy)
	ld a,(ixtest)
	cp 47
	call nz,Failure
	;dec
	ld a,229
	dec a
	cp 228
	call nz,Failure
	ld b,a
	dec b
	ld c,b
	dec c
	ld d,c
	dec d
	ld e,d
	dec e
	ld h,e
	dec h
	ld l,h
	dec l
	ld a,l
	cp 222
	call nz,Failure
	ld hl,scratch
	dec (hl)
	ld a,(hl)
	cp 23
	call nz,Failure
	dec (ix)
	dec (iy)
	ld a,(ixtest)
	cp 45
	call nz,Failure
	;daa
	ld a,15h
	ld b,27h
	add a,b
	daa
	cp 42h
	call nz,Failure
	;cpl
	ld a,11001001b
	cpl
	cp 00110110b
	call nz,Failure
	;neg
	ld a,10011000b
	neg
	cp 01101000b
	call nz,Failure
	;ccf
	ld a,4
	cp 5
	ccf
	call c,Failure
	ccf
	call nc,Failure
	;scf
	or a
	scf
	call nc,Failure
	;nop
	nop
	;add hl,ss
	ld hl,32*256+35
	ld bc,3*256+4
	add hl,bc
	ld a,l
	cp 39
	call nz,Failure
	ld a,h
	cp 35
	call nz,Failure
	ld de,2*256+10
	add hl,de
	ld a,l
	cp 49
	call nz,Failure
	ld a,h
	cp 37
	call nz,Failure
	add hl,hl
	ld a,l
	cp 98
	call nz,Failure
	ld a,h
	cp 74
	call nz,Failure
	ld sp,3*256+4
	add hl,sp
	ld a,l
	cp 102
	call nz,Failure
	ld a,h
	cp 77
	call nz,Failure
	ld sp,0ffffh
	;adc
	ld hl,24*256+3
	scf
	ld bc,3*256+4
	adc hl,bc
	ld a,l
	cp 8
	call nz,Failure
	ld a,h
	cp 27
	call nz,Failure
	ld de,2*256+4
	scf
	adc hl,de
	ld a,l
	cp 13
	call nz,Failure
	ld a,h
	cp 29
	call nz,Failure
	adc hl,hl
	ld a,l
	cp 26
	call nz,Failure
	ld a,h
	cp 58
	call nz,Failure
	adc hl,sp
	call nc,Failure
	ld a,l
	cp 25
	call nz,Failure
	ld a,h
	cp 58
	call nz,Failure
	;sbc
	ld hl,54*256+23
	or a
	ld bc,2*256+4
	sbc hl,bc
	ld a,l
	cp 19
	call nz,Failure
	ld a,h
	cp 52
	call nz,Failure
	ld de,52*256+19
	sbc hl,de
	call nz,Failure
	ld hl,2
	scf
	sbc hl,hl
	call nc,Failure
	ld hl,45
	or a
	sbc hl,sp
	ld a,l
	cp 46
	call nz,Failure
	;add ix
	ld ix,2000h
	ld bc,2004h
	ld de,2006h
	ld sp,2002h
	add ix,bc
	add ix,de
	add ix,sp
	ld a,23
	ld (800Ch),a
	ld a,(ix)
	ld sp,0ffffh
	cp 23
	call nz,Failure
	ld (8000h),a
	ld ix,4000h
	add ix,ix
	ld a,(ix)
	cp 23
	call nz,Failure
	;add iy
	ld iy,2000h
	ld bc,2004h
	ld de,2006h
	ld sp,2002h
	add iy,bc
	add iy,de
	add iy,sp
	ld a,23
	ld (800Ch),a
	ld sp,0ffffh
	ld a,(iy)
	cp 23
	call nz,Failure
	ld (8000h),a
	ld iy,4000h
	add iy,iy
	ld a,(iy)
	cp 23
	call nz,Failure
	;inc
	ld bc,2*256+255
	inc bc
	ld a,c
	cp 0
	call nz,Failure
	ld a,b
	cp 3
	call nz,Failure
	ld de,5
	inc de
	ld a,e
	cp 6
	call nz,Failure
	ld hl,9
	inc hl
	ld a,l
	cp 10
	call nz,Failure
	inc sp
	ld (scratch),sp
	ld a,(scratch)
	cp 0
	call nz,Failure
	ld a,(scratch+1)
	cp 0
	call nz,Failure
	ld a,201
	ld (ixtest+1),a
	ld ix,ixtest
	ld iy,ixtest
	inc ix
	inc iy
	ld a,(ix)
	cp 201
	call nz,Failure
	ld a,(iy)
	cp 201
	call nz,Failure
	;dec ss
	ld bc,2*256+0
	dec bc
	ld a,c
	cp 255
	call nz,Failure
	ld a,b
	cp 1
	call nz,Failure
	ld de,4
	dec de
	ld a,e
	cp 3
	call nz,Failure
	ld hl,7
	dec hl
	ld a,l
	cp 6
	call nz,Failure
	dec sp
	ld (scratch),sp
	ld a,(scratch)
	cp 255
	call nz,Failure
	ld a,(scratch+1)
	cp 255
	call nz,Failure
	;dec ix
	;dec iy
	ld ix,ixtest+2
	ld iy,ixtest+2
	dec ix
	dec iy
	ld a,(ix)
	cp 201
	call nz,Failure
	ld a,(iy)
	cp 201
	call nz,Failure
	;rlca
	ld a,10001000b
	rlca
	call nc,Failure
	cp 00010001b
	call nz,Failure
	;rla
	ld a,01110110b
	scf
	rla
	call c,Failure
	cp 11101101b
	call nz,Failure
	;rrca
	ld a,00010001b
	rrca
	call nc,Failure
	cp 10001000b
	call nz,Failure
	;rra
	ld a,11100001b
	or a
	rra
	call nc,Failure
	cp 01110000b
	call nz,Failure
	;rlc
	ld a,10001000b
	ld b,a
	ld c,a
	ld d,a
	ld e,a
   ld h,a
	ld l,a
	rlc a
	call nc,Failure
	cp 00010001b
	call nz,Failure
	rlc b
	call nc,Failure
	cp b
	call nz,Failure
	rlc c
	call nc,Failure
	cp c
	call nz,Failure
	rlc d
	call nc,Failure
	cp d
	call nz,Failure
	rlc e
	call nc,Failure
	cp e
	call nz,Failure
	rlc h
	call nc,Failure
	cp h
	call nz,Failure
	rlc l
	call nc,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),10001000b
	rlc (hl)
	call nc,Failure
	ld a,00010001b
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),10001000b
	rlc (ix)
	call nc,Failure
	ld a,00010001b
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),10001000b
	rlc (iy)
	call nc,Failure
	ld a,00010001b
	cp (iy)
	call nz,Failure
	;rl
	ld a,10001111b
	or a
	rl a
	call nc,Failure
	cp 00011110b
	call nz,Failure
	ld b,10001111b
	or a
	rl b
	call nc,Failure
	cp b
	call nz,Failure
	ld c,10001111b
	or a
	rl c
	call nc,Failure
	cp c
	call nz,Failure
	ld d,10001111b
	or a
	rl d
	call nc,Failure
	cp d
	call nz,Failure
	ld e,10001111b
	or a
	rl e
	call nc,Failure
	cp e
	call nz,Failure
	ld h,10001111b
	or a
	rl h
	call nc,Failure
	cp h
	call nz,Failure
	ld l,10001111b
	or a
	rl l
	call nc,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),10001111b
	rl (hl)
	call nc,Failure
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),10001111b
	rl (ix)
	call nc,Failure
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),10001111b
	rl (iy)
	call nc,Failure
	cp (iy)
	call nz,Failure
	;rrc
	ld a,00110001b
	rrc a
	call nc,Failure
	cp 10011000b
	call nz,Failure
	ld b,00110001b
	rrc b
	call nc,Failure
	cp b
	call nz,Failure
	ld c,00110001b
	rrc c
	call nc,Failure
	cp c
	call nz,Failure
	ld d,00110001b
	rrc d
	call nc,Failure
	cp d
	call nz,Failure
	ld e,00110001b
	rrc e
	call nc,Failure
	cp e
	call nz,Failure
	ld h,00110001b
	rrc h
	call nc,Failure
	cp h
	call nz,Failure
	ld l,00110001b
	rrc l
	call nc,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),00110001b
	rrc (hl)
	call nc,Failure
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),00110001b
	rrc (ix)
	call nc,Failure
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),00110001b
	rrc (iy)
	call nc,Failure
	cp (iy)
	call nz,Failure
	;rr
	ld a,11011101b
	or a
	rr a
	call nc,Failure
	cp 01101110b
	call nz,Failure
	ld b,11011101b
	or a
	rr b
	call nc,Failure
	cp b
	call nz,Failure
	ld c,11011101b
	or a
	rr c
	call nc,Failure
	cp c
	call nz,Failure
	ld d,11011101b
	or a
	rr d
	call nc,Failure
	cp d
	call nz,Failure
	ld e,11011101b
	or a
	rr e
	call nc,Failure
	cp e
	call nz,Failure
	ld h,11011101b
	or a
	rr h
	call nc,Failure
	cp h
	call nz,Failure
	ld l,11011101b
	or a
	rr l
	call nc,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),11011101b
	or a
	rr (hl)
	call nc,Failure
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),11011101b
	or a
	rr (ix)
	call nc,Failure
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),11011101b
	or a
	rr (iy)
	call nc,Failure
	cp (iy)
	call nz,Failure
	;sla
	ld a,10110001b
	sla a
	call nc,Failure
	cp 01100010b
	call nz,Failure
	ld b,10110001b
	sla b
	call nc,Failure
	cp b
	call nz,Failure
	ld c,10110001b
	sla c
	call nc,Failure
	cp c
	call nz,Failure
	ld d,10110001b
	sla d
	call nc,Failure
	cp d
	call nz,Failure
	ld e,10110001b
	sla e
	call nc,Failure
	cp e
	call nz,Failure
	ld h,10110001b
	sla h
	call nc,Failure
	cp h
	call nz,Failure
	ld l,10110001b
	sla l
	call nc,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),10110001b
	sla (hl)
	call nc,Failure
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),10110001b
	sla (ix)
	call nc,Failure
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),10110001b
	sla (iy)
	call nc,Failure
	cp (iy)
	call nz,Failure
	;sra
	ld a,10111000b
	sra a
	call c,Failure
	cp 11011100b
	call nz,Failure
	ld b,10111000b
	sra b
	call c,Failure
	cp b
	call nz,Failure
	ld c,10111000b
	sra c
	call c,Failure
	cp c
	call nz,Failure
	ld d,10111000b
	sra d
	call c,Failure
	cp d
	call nz,Failure
	ld e,10111000b
	sra e
	call c,Failure
	cp e
	call nz,Failure
	ld h,10111000b
	sra h
	call c,Failure
	cp h
	call nz,Failure
	ld l,10111000b
	sra l
	call c,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),10111000b
	sra (hl)
	call c,Failure
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),10111000b
	sra (ix)
	call c,Failure
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),10111000b
	sra (iy)
	call c,Failure
	cp (iy)
	call nz,Failure
	;srl
	ld a,10001111b
	srl a
	call nc,Failure
	cp 01000111b
	call nz,Failure
	ld b,10001111b
	srl b
	call nc,Failure
	cp b
	call nz,Failure
	ld c,10001111b
	srl c
	call nc,Failure
	cp c
	call nz,Failure
	ld d,10001111b
	srl d
	call nc,Failure
	cp d
	call nz,Failure
	ld e,10001111b
	srl e
	call nc,Failure
	cp e
	call nz,Failure
	ld h,10001111b
	srl h
	call nc,Failure
	cp h
	call nz,Failure
	ld l,10001111b
	srl l
	call nc,Failure
	cp l
	call nz,Failure
	ld hl,scratch
	ld (hl),10001111b
	srl (hl)
	call nc,Failure
	cp (hl)
	call nz,Failure
	ld ix,scratch
	ld (ix),10001111b
	srl (ix)
	call nc,Failure
	cp (ix)
	call nz,Failure
	ld iy,scratch
	ld (iy),10001111b
	srl (iy)
	call nc,Failure
	cp (iy)
	call nz,Failure
	;rld
	ld hl,scratch
	ld (hl),00110001b
	ld a,01111010b
	rld
	cp 01110011b
	call nz,Failure
	ld a,(hl)
	cp 00011010b
	call nz,Failure
	;rrd
	ld hl,scratch
	ld (hl),00100000b
	ld a,10000100b
	rrd
	cp 10000000b
	call nz,Failure
	ld a,(hl)
	cp 01000010b
	call nz,Failure
	;bit
	ld a,10101010b
	ld b,0
	ld c,0
	ld d,0
	ld e,0
	ld h,0
	ld l,0
	bit 0,a
	call nz,Failure
	bit 1,a
	call z,Failure
	bit 2,a
	call nz,Failure
	bit 3,a
	call z,Failure
	bit 4,a
	call nz,Failure
	bit 5,a
	call z,Failure
	bit 6,a
	call nz,Failure
	bit 7,a
	call z,Failure
	ld b,a
	bit 0,b
	call nz,Failure
	bit 1,b
	call z,Failure
	bit 2,b
	call nz,Failure
	bit 3,b
	call z,Failure
	bit 4,b
	call nz,Failure
	bit 5,b
	call z,Failure
	bit 6,b
	call nz,Failure
	bit 7,b
	call z,Failure
	ld c,a
	bit 0,c
	call nz,Failure
	bit 1,c
	call z,Failure
	bit 2,c
	call nz,Failure
	bit 3,c
	call z,Failure
	bit 4,c
	call nz,Failure
	bit 5,c
	call z,Failure
	bit 6,c
	call nz,Failure
	bit 7,c
	call z,Failure
	ld d,a
	bit 0,d
	call nz,Failure
	bit 1,d
	call z,Failure
	bit 2,d
	call nz,Failure
	bit 3,d
	call z,Failure
	bit 4,d
	call nz,Failure
	bit 5,d
	call z,Failure
	bit 6,d
	call nz,Failure
	bit 7,d
	call z,Failure
	ld e,a
	bit 0,e
	call nz,Failure
	bit 1,e
	call z,Failure
	bit 2,e
	call nz,Failure
	bit 3,e
	call z,Failure
	bit 4,e
	call nz,Failure
	bit 5,e
	call z,Failure
	bit 6,e
	call nz,Failure
	bit 7,e
	call z,Failure
	ld h,a
	bit 0,h
	call nz,Failure
	bit 1,h
	call z,Failure
	bit 2,h
	call nz,Failure
	bit 3,h
	call z,Failure
	bit 4,h
	call nz,Failure
	bit 5,h
	call z,Failure
	bit 6,h
	call nz,Failure
	bit 7,h
	call z,Failure
	ld l,a
	bit 0,l
	call nz,Failure
	bit 1,l
	call z,Failure
	bit 2,l
	call nz,Failure
	bit 3,l
	call z,Failure
	bit 4,l
	call nz,Failure
	bit 5,l
	call z,Failure
	bit 6,l
	call nz,Failure
	bit 7,l
	call z,Failure
	ld hl,scratch
	ld (hl),a
	bit 0,(hl)
	call nz,Failure
	bit 1,(hl)
	call z,Failure
	bit 2,(hl)
	call nz,Failure
	bit 3,(hl)
	call z,Failure
	bit 4,(hl)
	call nz,Failure
	bit 5,(hl)
	call z,Failure
	bit 6,(hl)
	call nz,Failure
	bit 7,(hl)
	call z,Failure
	ld ix,scratch
	bit 0,(ix)
	call nz,Failure
	bit 1,(ix)
	call z,Failure
	bit 2,(ix)
	call nz,Failure
	bit 3,(ix)
	call z,Failure
	bit 4,(ix)
	call nz,Failure
	bit 5,(ix)
	call z,Failure
	bit 6,(ix)
	call nz,Failure
	bit 7,(ix)
	call z,Failure
	ld iy,scratch
	bit 0,(iy)
	call nz,Failure
	bit 1,(iy)
	call z,Failure
	bit 2,(iy)
	call nz,Failure
	bit 3,(iy)
	call z,Failure
	bit 4,(iy)
	call nz,Failure
	bit 5,(iy)
	call z,Failure
	bit 6,(iy)
	call nz,Failure
	bit 7,(iy)
	call z,Failure
	xor a
	set 0,a
	cp 1
	call nz,Failure
	set 1,a
	cp 3
	call nz,Failure
	set 2,a
	cp 7
	call nz,Failure
	set 3,a
	cp 15
	call nz,Failure
	set 4,a
	cp 31
	call nz,Failure
	set 5,a
	cp 63
	call nz,Failure
	set 6,a
	cp 127
	call nz,Failure
	set 7,a
	cp 255
	call nz,Failure
	ld b,0
	set 0,b
	ld a,b
	cp 1
	call nz,Failure
	set 1,b
	ld a,b
	cp 3
	call nz,Failure
	set 2,b
	ld a,b
	cp 7
	call nz,Failure
	set 3,b
	ld a,b
	cp 15
	call nz,Failure
	set 4,b
	ld a,b
	cp 31
	call nz,Failure
	set 5,b
	ld a,b
	cp 63
	call nz,Failure
	set 6,b
	ld a,b
	cp 127
	call nz,Failure
	set 7,b
	ld a,b
	cp 255
	call nz,Failure
	ld c,0
	set 0,c
	ld a,c
	cp 1
	call nz,Failure
	set 1,c
	ld a,c
	cp 3
	call nz,Failure
	set 2,c
	ld a,c
	cp 7
	call nz,Failure
	set 3,c
	ld a,c
	cp 15
	call nz,Failure
	set 4,c
	ld a,c
	cp 31
	call nz,Failure
	set 5,c
	ld a,c
	cp 63
	call nz,Failure
	set 6,c
	ld a,c
	cp 127
	call nz,Failure
	set 7,c
	ld a,c
	cp 255
	call nz,Failure
	ld d,0
	set 0,d
	ld a,d
	cp 1
	call nz,Failure
	set 1,d
	ld a,d
	cp 3
	call nz,Failure
	set 2,d
	ld a,d
	cp 7
	call nz,Failure
	set 3,d
	ld a,d
	cp 15
	call nz,Failure
	set 4,d
	ld a,d
	cp 31
	call nz,Failure
	set 5,d
	ld a,d
	cp 63
	call nz,Failure
	set 6,d
	ld a,d
	cp 127
	call nz,Failure
	set 7,d
	ld a,d
	cp 255
	call nz,Failure
	ld e,0
	set 0,e
	ld a,e
	cp 1
	call nz,Failure
	set 1,e
	ld a,e
	cp 3
	call nz,Failure
	set 2,e
	ld a,e
	cp 7
	call nz,Failure
	set 3,e
	ld a,e
	cp 15
	call nz,Failure
	set 4,e
	ld a,e
	cp 31
	call nz,Failure
	set 5,e
	ld a,e
	cp 63
	call nz,Failure
	set 6,e
	ld a,e
	cp 127
	call nz,Failure
	set 7,e
	ld a,e
	cp 255
	call nz,Failure
	ld h,0
	set 0,h
	ld a,h
	cp 1
	call nz,Failure
	set 1,h
	ld a,h
	cp 3
	call nz,Failure
	set 2,h
	ld a,h
	cp 7
	call nz,Failure
	set 3,h
	ld a,h
	cp 15
	call nz,Failure
	set 4,h
	ld a,h
	cp 31
	call nz,Failure
	set 5,h
	ld a,h
	cp 63
	call nz,Failure
	set 6,h
	ld a,h
	cp 127
	call nz,Failure
	set 7,h
	ld a,h
	cp 255
	call nz,Failure
	ld l,0
	set 0,l
	ld a,l
	cp 1
	call nz,Failure
	set 1,l
	ld a,l
	cp 3
	call nz,Failure
	set 2,l
	ld a,l
	cp 7
	call nz,Failure
	set 3,l
	ld a,l
	cp 15
	call nz,Failure
	set 4,l
	ld a,l
	cp 31
	call nz,Failure
	set 5,l
	ld a,l
	cp 63
	call nz,Failure
	set 6,l
	ld a,l
	cp 127
	call nz,Failure
	set 7,l
	ld a,l
	cp 255
	call nz,Failure
	ld hl,scratch
	ld (hl),0
	set 0,(hl)
	ld a,(hl)
	cp 1
	call nz,Failure
	set 1,(hl)
	ld a,(hl)
	cp 3
	call nz,Failure
	set 2,(hl)
	ld a,(hl)
	cp 7
	call nz,Failure
	set 3,(hl)
	ld a,(hl)
	cp 15
	call nz,Failure
	set 4,(hl)
	ld a,(hl)
	cp 31
	call nz,Failure
	set 5,(hl)
	ld a,(hl)
	cp 63
	call nz,Failure
	set 6,(hl)
	ld a,(hl)
	cp 127
	call nz,Failure
	set 7,(hl)
	ld a,(hl)
	cp 255
	call nz,Failure
	ld ix,scratch
	ld (ix),0
	set 0,(ix)
	ld a,(ix)
	cp 1
	call nz,Failure
	set 1,(ix)
	ld a,(ix)
	cp 3
	call nz,Failure
	set 2,(ix)
	ld a,(ix)
	cp 7
	call nz,Failure
	set 3,(ix)
	ld a,(ix)
	cp 15
	call nz,Failure
	set 4,(ix)
	ld a,(ix)
	cp 31
	call nz,Failure
	set 5,(ix)
	ld a,(ix)
	cp 63
	call nz,Failure
	set 6,(ix)
	ld a,(ix)
	cp 127
	call nz,Failure
	set 7,(ix)
	ld a,(ix)
	cp 255
	call nz,Failure
	ld iy,scratch
	ld (iy),0
	set 0,(iy)
	ld a,(iy)
	cp 1
	call nz,Failure
	set 1,(iy)
	ld a,(iy)
	cp 3
	call nz,Failure
	set 2,(iy)
	ld a,(iy)
	cp 7
	call nz,Failure
	set 3,(iy)
	ld a,(iy)
	cp 15
	call nz,Failure
	set 4,(iy)
	ld a,(iy)
	cp 31
	call nz,Failure
	set 5,(iy)
	ld a,(iy)
	cp 63
	call nz,Failure
	set 6,(iy)
	ld a,(iy)
	cp 127
	call nz,Failure
	set 7,(iy)
	ld a,(iy)
	cp 255
	call nz,Failure
	;res
	ld a,255
	res 0,a
	cp 254
	call nz,Failure
	res 1,a
	cp 252
	call nz,Failure
	res 2,a
	cp 248
	call nz,Failure
	res 3,a
	cp 240
	call nz,Failure
	res 4,a
	cp 224
	call nz,Failure
	res 5,a
	cp 192
	call nz,Failure
	res 6,a
	cp 128
	call nz,Failure
	res 7,a
	cp 0
	call nz,Failure
	ld b,255
	res 0,b
	ld a,b
	cp 254
	call nz,Failure
	res 1,b
	ld a,b
	cp 252
	call nz,Failure
	res 2,b
	ld a,b
	cp 248
	call nz,Failure
	res 3,b
	ld a,b
	cp 240
	call nz,Failure
	res 4,b
	ld a,b
	cp 224
	call nz,Failure
	res 5,b
	ld a,b
	cp 192
	call nz,Failure
	res 6,b
	ld a,b
	cp 128
	call nz,Failure
	res 7,b
	ld a,b
	cp 0
	call nz,Failure
	ld c,255
	res 0,c
	ld a,c
	cp 254
	call nz,Failure
	res 1,c
	ld a,c
	cp 252
	call nz,Failure
	res 2,c
	ld a,c
	cp 248
	call nz,Failure
	res 3,c
	ld a,c
	cp 240
	call nz,Failure
	res 4,c
	ld a,c
	cp 224
	call nz,Failure
	res 5,c
	ld a,c
	cp 192
	call nz,Failure
	res 6,c
	ld a,c
	cp 128
	call nz,Failure
	res 7,c
	ld a,c
	cp 0
	call nz,Failure
	ld d,255
	res 0,d
	ld a,d
	cp 254
	call nz,Failure
	res 1,d
	ld a,d
	cp 252
	call nz,Failure
	res 2,d
	ld a,d
	cp 248
	call nz,Failure
	res 3,d
	ld a,d
	cp 240
	call nz,Failure
	res 4,d
	ld a,d
	cp 224
	call nz,Failure
	res 5,d
	ld a,d
	cp 192
	call nz,Failure
	res 6,d
	ld a,d
	cp 128
	call nz,Failure
	res 7,d
	ld a,d
	cp 0
	call nz,Failure
	ld e,255
	res 0,e
	ld a,e
	cp 254
	call nz,Failure
	res 1,e
	ld a,e
	cp 252
	call nz,Failure
	res 2,e
	ld a,e
	cp 248
	call nz,Failure
	res 3,e
	ld a,e
	cp 240
	call nz,Failure
	res 4,e
	ld a,e
	cp 224
	call nz,Failure
	res 5,e
	ld a,e
	cp 192
	call nz,Failure
	res 6,e
	ld a,e
	cp 128
	call nz,Failure
	res 7,e
	ld a,e
	cp 0
	call nz,Failure
	ld h,255
	res 0,h
	ld a,h
	cp 254
	call nz,Failure
	res 1,h
	ld a,h
	cp 252
	call nz,Failure
	res 2,h
	ld a,h
	cp 248
	call nz,Failure
	res 3,h
	ld a,h
	cp 240
	call nz,Failure
	res 4,h
	ld a,h
	cp 224
	call nz,Failure
	res 5,h
	ld a,h
	cp 192
	call nz,Failure
	res 6,h
	ld a,h
	cp 128
	call nz,Failure
	res 7,h
	ld a,h
	cp 0
	call nz,Failure
	ld l,255
	res 0,l
	ld a,l
	cp 254
	call nz,Failure
	res 1,l
	ld a,l
	cp 252
	call nz,Failure
	res 2,l
	ld a,l
	cp 248
	call nz,Failure
	res 3,l
	ld a,l
	cp 240
	call nz,Failure
	res 4,l
	ld a,l
	cp 224
	call nz,Failure
	res 5,l
	ld a,l
	cp 192
	call nz,Failure
	res 6,l
	ld a,l
	cp 128
	call nz,Failure
	res 7,l
	ld a,l
	cp 0
	call nz,Failure
	ld hl,scratch
	ld (hl),255
	res 0,(hl)
	ld a,(hl)
	cp 254
	call nz,Failure
	res 1,(hl)
	ld a,(hl)
	cp 252
	call nz,Failure
	res 2,(hl)
	ld a,(hl)
	cp 248
	call nz,Failure
	res 3,(hl)
	ld a,(hl)
	cp 240
	call nz,Failure
	res 4,(hl)
	ld a,(hl)
	cp 224
	call nz,Failure
	res 5,(hl)
	ld a,(hl)
	cp 192
	call nz,Failure
	res 6,(hl)
	ld a,(hl)
	cp 128
	call nz,Failure
	res 7,(hl)
	ld a,(hl)
	cp 0
	call nz,Failure
	ld ix,scratch
	ld (ix),255
	res 0,(ix)
	ld a,(ix)
	cp 254
	call nz,Failure
	res 1,(ix)
	ld a,(ix)
	cp 252
	call nz,Failure
	res 2,(ix)
	ld a,(ix)
	cp 248
	call nz,Failure
	res 3,(ix)
	ld a,(ix)
	cp 240
	call nz,Failure
	res 4,(ix)
	ld a,(ix)
	cp 224
	call nz,Failure
	res 5,(ix)
	ld a,(ix)
	cp 192
	call nz,Failure
	res 6,(ix)
	ld a,(ix)
	cp 128
	call nz,Failure
	res 7,(ix)
	ld a,(ix)
	cp 0
	call nz,Failure
	ld iy,scratch
	ld (iy),255
	res 0,(iy)
	ld a,(iy)
	cp 254
	call nz,Failure
	res 1,(iy)
	ld a,(iy)
	cp 252
	call nz,Failure
	res 2,(iy)
	ld a,(iy)
	cp 248
	call nz,Failure
	res 3,(iy)
	ld a,(iy)
	cp 240
	call nz,Failure
	res 4,(iy)
	ld a,(iy)
	cp 224
	call nz,Failure
	res 5,(iy)
	ld a,(iy)
	cp 192
	call nz,Failure
	res 6,(iy)
	ld a,(iy)
	cp 128
	call nz,Failure
	res 7,(iy)
	ld a,(iy)
	cp 0
	call nz,Failure
	;jp
	jp line1
	call Failure
line1:
	ld a,45
	or a
	jp z,jpfailure
	xor a
	jp z,line2
	call Failure
line2:
	xor a
	jp nz,jpfailure
	or 5
	jp nz,line3
	call Failure
line3:
	ld a,5
	cp 7
	jp nc,jpfailure
	cp 2
	jp nc,line4
	call Failure
line4:
	ld a,8
	cp 7
	jp c,jpfailure
	cp 9
	jp c,line5
	call Failure
line5:
	ld a,3
	or a
	rl a
	jp po,jpfailure
	ld a,8
	or a
	rr a
	jp po,line6
	call Failure
line6:
	ld a,8
	or a
	rr a
	jp pe,jpfailure
	ld a,3
	or a
	rl a
	jp pe,line7
	call Failure
line7:
	ld a,54
	or a
	jp m,jpfailure
	ld a,-5
	or a
	jp m,line8
	call Failure
line8:
	ld a,-5
	or a
	jp p,jpfailure
	ld a,54
	or a
	jp p,line9
	call Failure
line9:
	jr line10
	call Failure
jrfailure:
	call Failure
line10:
	ld a,10
	cp 9
	jr c,jrfailure
	cp 11
	jr c,line11
	call Failure
line11:
	xor a
	jr nz,jrfailure
	or 1
	jr nz,line12
	call Failure
line12:
	or 5
	jr z,jrfailure
	xor a
	jr z,line13
	call Failure
line13:
	ld hl,line14
	jp (hl)
	call Failure
line14:
	ld ix,line15
	jp (ix)
	call Failure
line15:
	ld iy,line16
	jp (iy)
	call Failure
line16:
	;djnz
	ld b,2
	djnz line17
	call Failure
line17:
	ld a,b
	cp 1
	call nz,Failure
	ld b,1
	djnz jrfailure
	ld a,b
	or a
	call nz,Failure
	;call
	;ret
	ld a,200
	call tempcall
	cp 23
	call nz,Failure
	;call nz
	or 5
	call nz,routine1
	or a
	call nz,Failure
	;call z
	xor a
	call z,routine2
	cp 5
	call nz,Failure
	or 5
	call z,Failure
	;call nc
	ld a,4
	cp 6
	call nc,Failure
	cp 2
	call nc,routine3
	cp 8
	call nz,Failure
	;call c
	ld a,4
	cp 2
	call c,Failure
	cp 8
	call c,routine4
	cp 209
	call nz,Failure
	;call po
	ld a,3
	or a
	rl a
	call po,Failure
	ld a,8
	or a
	rr a
	call po,routine5
	cp 188
	call nz,Failure
	;call pe
	ld a,8
	or a
	rr a
	call pe,Failure
	ld a,3
	or a
	rl a
	call pe,routine6
	cp 222
	call nz,Failure
	;call p
	ld a,-5
	or a
	call p,Failure
	ld a,3
	or a
	call p,routine7
	cp 87
	call nz,Failure
	;call m
	ld a,3
	or a
	call m,Failure
	ld a,-3
	or a
	call m,routine8
	cp 237
   call nz,Failure
	;ret cc
	call retconditiontesting
	call Failure
resumepoint:
	xor a
	rst 00h
	cp 50h
	call nz,Failure
	xor a
	rst 08h
	cp 58h
	call nz,Failure
	xor a
	rst 10h
	cp 60h
	call nz,Failure
	xor a
	rst 18h
	cp 68h
	call nz,Failure
	xor a
	rst 20h
	cp 70h
	call nz,Failure
	xor a
	rst 28h
	cp 78h
	call nz,Failure
	xor a
	rst 30h
	cp 80h
	call nz,Failure
	xor a
	rst 38h
	cp 88h
	call nz,Failure
Loop:
	jp Loop
retconditiontesting:
	;ret nz
	xor a
	ret nz
	;ret z
	or 5
	ret z
	;ret nc
	ld a,3
	cp 5
	ret nc
	;ret c
	ld a,3
	cp 1
	ret c
	;ret pe
	ld a,1
	or a
	rl a
	ret pe
	;ret po
	ld a,3
	or a
	rl a
	ret po
	;ret p
	ld a,-3
	or a
	ret p
	;ret m
	ld a,87
	or a
	ret m
	ld hl,resumepoint
	ex (sp),hl
	call nztest
	call ztest
	call nctest
	call ctest
	call potest
	call petest
	call ptest
	call mtest
	call retitest
	call retptest
	ret
retitest:
	reti
	call Failure
retptest:
	retn
	call Failure
ptest:
	ld a,5
	or a
	ret p
	call Failure
mtest:
	ld a,-3
	or a
	ret m
	call Failure
petest:
	ld a,3
	or a
	rl a
	ret pe
	call Failure
potest:
	ld a,1
	or a
	rl a
	ret po
	call Failure
ctest:
	ld a,5
	cp 6
	ret c
	call Failure
nctest:
	ld a,5
	cp 3
	ret nc
	call Failure
ztest:
	xor a
	ret z
	call Failure
nztest:
	or 5
	ret nz
	call Failure
routine8:
	ld a,237
	ret
routine7:
	ld a,87
	ret
routine6:
	ld a,222
	ret
routine5:
	ld a,188
	ret
routine4:
	ld a,209
	ret
routine3:
	ld a,8
	ret
routine2:
	ld a,5
	ret
routine1:
	xor a
	ret
tempcall:
	ld a,23
	ret
jpfailure:
	call Failure
testdata:
	DB 1,2,3
Failure:
	DB 0EDh,0FDh	
