loadFromIX MACRO reg
	call DD_LoadRFromIX
	exx
	ld &reg,a
	exx
	ret		;CHANGE_ME
	.ENDM
loadIntoIX MACRO reg
	exx
	ld a,&reg
	exx
	ld c,a
	jp DD_WriteToIX
	.ENDM
logicalIX MACRO op
	pop hl
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	&op (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
logicalIX2 MACRO op
	call DD_LoadRFromIX
	ld b,a
	ex af,af'
	&op b
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
resBitIX MACRO bitn
	pop hl
	ld a,(currentRAMPage)
	out (7),a
	res &bitn,(hl)
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
setBitIX MACRO bitn
	pop hl
	ld a,(currentRAMPage)
	out (7),a
	set &bitn,(hl)
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
bitIX MACRO bitn
	pop hl
	call Fetch_Byte_HL
	ex af,af'
	bit &bitn,e
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
Opcode_DD:
	inc ix
	inc iy
	ld l,e
	ld h,48h >> 1
	add hl,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
DD_E9:
	;jp (ix)
	ld ix,(registerIX)
	jp Optimize_PC
DD_CB:
	call DD_LoadRFromIX
	push hl
	call Fetch_Byte_PC
	ld d,0
	ld hl,Opcode_DD_CB_Table
	ld b,e
	ld a,e
	srl a
	srl a
	and 11111100b
	ld e,a
	ld a,b
	and 8
	srl a
	srl a
	add a,e
	ld e,a
	add hl,de
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
Opcode_DD_CB_Table:
	DW DD_CB_06
	DW DD_CB_0E
	DW DD_CB_16
	DW DD_CB_1E
	DW DD_CB_26
	DW DD_CB_2E
	DW DD_CB_36
	DW DD_CB_3E
	DW DD_CB_46
	DW DD_CB_4E
	DW DD_CB_56
	DW DD_CB_5E
	DW DD_CB_66
	DW DD_CB_6E
	DW DD_CB_76
	DW DD_CB_7E
	DW DD_CB_86
	DW DD_CB_8E
	DW DD_CB_96
	DW DD_CB_9E
	DW DD_CB_A6
	DW DD_CB_AE
	DW DD_CB_B6
	DW DD_CB_BE
	DW DD_CB_C6
	DW DD_CB_CE
	DW DD_CB_D6
	DW DD_CB_DE
	DW DD_CB_E6
	DW DD_CB_EE
	DW DD_CB_F6
	DW DD_CB_FE
DD_CB_BE:
	;res 7,(ix+d)
	resBitIX 7
DD_CB_B6:
	;res 6,(ix+d)
	resBitIX 6
DD_CB_AE:
	;res 5,(ix+d)
	resBitIX 5
DD_CB_A6:
	;res 4,(ix+d)
	resBitIX 4
DD_CB_9E:
	;res 3,(ix+d)
	resBitIX 3
DD_CB_96:
	;res 2,(ix+d)
	resBitIX 2
DD_CB_8E:
	;res 1,(ix+d)
	resBitIX 1
DD_CB_86:
	;res 0,(ix+d)
	resBitIX 0
DD_CB_7E:
	;bit 7,(ix+d)
	bitIX 7
DD_CB_76:
	;bit 6,(ix+d)
	bitIX 6
DD_CB_6E:
	;bit 5,(ix+d)
	bitIX 5
DD_CB_66:
	;bit 4,(ix+d)
	bitIX 4
DD_CB_5E:
	;bit 3,(ix+d)
	bitIX 3
DD_CB_56:
	;bit 2,(ix+d)
	bitIX 2
DD_CB_4E:
	;bit 1,(ix+d)
	bitIX 1
DD_CB_46:
	;bit 0,(ix+d)
	bitIX 0
DD_CB_FE:
	;set 7,(ix+d)
	setBitIX 7
DD_CB_F6:
	;set 6,(ix+d)
	setBitIX 6
DD_CB_EE:
	;set 5,(ix+d)
	setBitIX 5
DD_CB_E6:
	;set 4,(ix+d)
	setBitIX 4
DD_CB_DE:
	;set 3,(ix+d)
	setBitIX 3
DD_CB_D6:
	;set 2,(ix+d)
	setBitIX 2
DD_CB_CE:
	;set 1,(ix+d)
	setBitIX 1
DD_CB_C6:
	;set 0,(ix+d)
	setBitIX 0
DD_CB_3E:
	;srl (ix)
	logicalIX srl
DD_CB_36:
	;sll (ix)
	pop hl
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	sla (hl)
	set 0,(hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_CB_2E:
	;sra (ix)
	logicalIX sra
DD_CB_26:
	;sla (ix)
	pop hl
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	sla (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_CB_1E:
	;rr (ix)
	logicalIX rr
DD_CB_0E:
	;rrc (ix)
	logicalIX rrc
DD_CB_16:
	;rl (ix)
	logicalIX rl
DD_CB_06:
	;rlc (ix)
	logicalIX rlc
DD_2B:
	;dec ix
	ld hl,(registerIX)
	dec hl
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_23:
	;inc ix
	ld hl,(registerIX)
	inc hl
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_09:
	;add ix,bc
	ld hl,(registerIX)
	exx
	push bc
	exx
	pop bc
	ex af,af'
	add hl,bc
	ex af,af'
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_19:
	;add ix,de
	ld hl,(registerIX)
	exx
	push de
	exx
	pop de
	ex af,af'
	add hl,de
	ex af,af'
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_29:
	;add ix,ix
	ld hl,(registerIX)
	ex af,af'
	add hl,hl
	ex af,af'
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_39:
	;add ix,sp
	ld hl,(registerIX)
	ld bc,(registerSP)
	ex af,af'
	add hl,bc
	ex af,af'
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_34:
	;inc (ix+d)
	call Fetch_Byte_PC
	ld hl,(registerIX)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	inc (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_35:
	;dec (ix+d)
	call Fetch_Byte_PC
	ld hl,(registerIX)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	dec (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_BE:
	;cp (ix+d)
	logicalIX2 cp
DD_AE:
	;xor (ix+d)
	logicalIX2 xor
DD_B6:
	;or (ix+d)
	logicalIX2 or
DD_A6:
	;and (ix+d)
	logicalIX2 and
DD_9E:
	;sbc a,(ix+d)
	logicalIX2 sbc
DD_96:
	;sub (ix+d)
	logicalIX2 sub
DD_8E:
	;adc a,(ix+d)
	logicalIX2 adc
DD_86:
	;add a,(ix+d)
	logicalIX2 add
DD_E3:
	;ex (sp),ix
	ld sp,(registerSP)
	ld hl,(registerIX)
	ld a,(currentRAMPage)
	out (7),a
	ex (sp),hl
	ld a,81h
	out (7),a
	ld (registerIX),hl
	ld sp,speedstack
	ret		;CHANGE_ME
DD_E1:
	;pop ix
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	pop hl
	ld a,81h
	out (7),a
	ld (registerIX),hl
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
DD_E5:
	;push ix
	ld sp,(registerSP)
	ld hl,(registerIX)
	ld a,(currentRAMPage)
	out (7),a
	push hl
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
DD_F9:
	;ld sp,ix
	ld hl,(registerIX)
	ld (registerSP),hl
	ret		;CHANGE_ME
DD_22:
	;ld (nnnn),ix
	ld de,(registerIX)
	inc ix
	inc ix
	ld a,(currentRAMPage)
	ld c,a
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,c
	out (7),a
	ld (hl),e
	inc hl
	ld (hl),d
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_2A:
	;ld ix,(nnnn)
	inc ix
	inc ix
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,81h
	out (7),a
	;HL is nnnn
	bit 7,h				;8
	jr nz,DD_2A_RAM	;12/7
	bit 6,h				;8
	jr z,DD_2A_0	;12/7
	push hl				;11
	set 7,h				;8
	res 6,h				;8
	ld a,(currompage)	;13
	out (7),a			;11
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,81h				;7
	out (7),a			;11
	ld (registerIX),de
	ret		;CHANGE_ME
DD_2A_0:
	set 7,h				;4
	ld a,(basepage)	;13
	out (7),a			;11
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,81h				;7
	out (7),a			;11
	ld (registerIX),de
	ret		;CHANGE_ME
DD_2A_RAM:
	ld a,(currentRAMPage)	;13
	out (7),a			;11
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,81h				;7
	out (7),a			;11
	ld (registerIX),de
	ret		;CHANGE_ME
DD_21:
	;ld ix,nnnn
	inc ix
	inc ix
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,81h
	out (7),a
	ld (registerIX),hl
	ret		;CHANGE_ME
DD_36:
	;ld (ix+n),nn
	call DD_FindIX
	inc ix
	inc iy
	ld a,(currentRAMPage)
	ld d,a
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,d
	out (7),a
	ld (hl),e
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_77:
	ex af,af'
	ld c,a
	ex af,af'
	jp DD_WriteToIX
DD_70:
	loadIntoIX b
DD_71:
	loadIntoIX c
DD_72:
	loadIntoIX d
DD_73:
	loadIntoIX e
DD_74:
	loadIntoIX h
DD_75:
	loadIntoIX l
DD_7E:
	call DD_LoadRFromIX
	ld b,a
	ex af,af'
	ld a,b
	ex af,af'
	ret		;CHANGE_ME
DD_4E:
	loadFromIX c
DD_46:
	loadFromIX b
DD_56:
	loadFromIX d
DD_5E:
	loadFromIX e
DD_66:
	loadFromIX h
DD_6E:
	loadFromIX l
DD_LoadRFromIX:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld hl,(registerIX)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	bit 7,h				;8
	jr nz,DD_LoadRFromIX_RAM	;12/7
	bit 6,h				;8
	jr z,DD_LoadRFromIX_0	;12/7
	push hl				;11
	set 7,h				;8
	res 6,h				;8
	ld a,(currompage)	;13
	out (7),a			;11
	ld e,(hl)			;7
	ld a,81h				;7
	out (7),a			;11
	pop hl				;11
	ld a,e
	ret		;CHANGE_ME
DD_LoadRFromIX_0:
	set 7,h				;4
	ld a,(basepage)	;13
	out (7),a			;11
	ld e,(hl)			;7
	res 7,h
	ld a,81h				;7
	out (7),a			;11
	ld a,e
	ret		;CHANGE_ME
DD_LoadRFromIX_RAM:
	ld a,(currentRAMPage)	;13
	out (7),a			;11
	ld e,(hl)			;7
	ld a,81h				;7
	out (7),a			;11
	ld a,e
	ret		;CHANGE_ME
DD_WriteToIX:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld hl,(registerIX)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld a,(currentRAMPage)
	out (7),a
	ld (hl),c
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
DD_FindIX:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld hl,(registerIX)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ret		;CHANGE_ME
DD_0:	
DD_1:
DD_2:	
DD_3:	
DD_4:	
DD_5:	
DD_6:	
DD_7:	
DD_8:	
DD_A:	
DD_B:	
DD_C:	
DD_D:	
DD_E:	
DD_F:	
DD_10:	
DD_11:	
DD_12:	
DD_13:	
DD_14:	
DD_15:	
DD_16:	
DD_17:	
DD_18:	
DD_20:	
DD_24:	
DD_25:	
DD_26:	
DD_27:	
DD_28:	
DD_2C:	
DD_2D:	
DD_2E:	
DD_2F:	
DD_30:	
DD_31:	
DD_32:	
DD_33:	
DD_37:	
DD_38:	
DD_3A:	
DD_3B:	
DD_3C:	
DD_3D:	
DD_3E:	
DD_3F:	
DD_40:	
DD_41:	
DD_42:	
DD_43:	
DD_44:	
DD_45:	
DD_47:	
DD_48:	
DD_49:	
DD_4A:	
DD_4B:	
DD_4C:	
DD_4D:	
DD_4F:	
DD_50:	
DD_51:	
DD_52:	
DD_53:	
DD_54:	
DD_55:	
DD_57:	
DD_58:	
DD_59:	
DD_5A:	
DD_5B:	
DD_5C:	
DD_5D:	
DD_5F:	
DD_60:	
DD_61:	
DD_62:	
DD_63:	
DD_64:	
DD_65:	
DD_67:	
DD_68:	
DD_69:	
DD_6A:	
DD_6B:	
DD_6C:	
DD_6D:	
DD_6F:	
DD_78:	
DD_79:	
DD_7A:	
DD_7B:	
DD_7C:	
DD_7D:	
DD_7F:	
DD_80:	
DD_81:	
DD_82:	
DD_83:	
DD_84:	
DD_85:	
DD_87:	
DD_88:	
DD_89:	
DD_8A:	
DD_8B:	
DD_8C:	
DD_8D:	
DD_8F:	
DD_90:	
DD_91:	
DD_92:	
DD_93:	
DD_94:	
DD_95:	
DD_97:	
DD_98:	
DD_99:	
DD_9A:	
DD_9B:	
DD_9C:	
DD_9D:	
DD_9F:	
DD_A0:	
DD_A1:	
DD_A2:	
DD_A3:	
DD_A4:	
DD_A5:	
DD_A7:	
DD_A8:	
DD_A9:	
DD_AA:	
DD_AB:	
DD_AC:	
DD_AD:	
DD_AF:	
DD_B0:	
DD_B1:	
DD_B2:	
DD_B3:	
DD_B4:	
DD_B5:	
DD_B7:	
DD_B8:	
DD_B9:	
DD_BA:	
DD_BB:	
DD_BC:	
DD_BD:	
DD_BF:	
DD_C0:	
DD_C1:	
DD_C2:	
DD_C3:	
DD_C4:
	
DD_C5:
	
DD_C6:
	
DD_C7:
	
DD_C8:
	
DD_C9:
	
DD_CA:
	
DD_CC:
	
DD_CD:
	
DD_CE:
	
DD_CF:
	
DD_D0:
	
DD_D1:
	
DD_D2:
	
DD_D3:
	
DD_D4:
	
DD_D5:
	
DD_D6:
	
DD_D7:
	
DD_D8:
	
DD_D9:
	
DD_DA:
	
DD_DB:
	
DD_DC:
	
DD_DD:
	
DD_DE:
	
DD_DF:
	
DD_E0:
	
DD_E2:
	
DD_E4:
	
DD_E6:
	
DD_E7:
	
DD_E8:
	
DD_EA:
	
DD_EB:
	
DD_EC:
	
DD_ED:
	
DD_EE:
	
DD_EF:
	
DD_F0:
	
DD_F1:
	
DD_F2:
	
DD_F3:
	
DD_F4:
	
DD_F5:
	
DD_F6:
	
DD_F7:
DD_F8:
DD_FA:
DD_FB:	
DD_FC:	
DD_FD:	
DD_FE:	
DD_FF:	
DD_1A:	
DD_1B:	
DD_1C:	
DD_1D:	
DD_1E:	
DD_1F:	
DD_76:
	call Debug
	ret
