jrCond MACRO cond
	inc ix
	inc iy
	ex af,af'
	jr &cond,Opcode_38_Jump
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
condJPPre MACRO
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,81h
	out (7),a
	.ENDM
condCallPre MACRO
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,81h
	out (7),a
	.ENDM
rstM MACRO addr
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	push ix
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ld ix,addr
	jp Optimize_PC
	.ENDM
Opcode_C7:
	;rst 00h
	rstM 0
Opcode_CF:
	;rst 08h
	rstM 8
Opcode_D7:
	;rst 10h
	rstM 10h
Opcode_DF:
	;rst 18h
	rstM 18h
Opcode_E7:
	;rst 20h
	rstM 20h
Opcode_EF:
	;rst 28h
	rstM 28h
Opcode_F7:
	;rst 30h
	rstM 30h
Opcode_FF:
	;rst 38h
	rstM 38h
Opcode_Ret:
	ex af,af'
ED_4D:
	;reti
ED_45:
	;retn
Opcode_C9:
	;ret
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	pop ix
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	jp Optimize_PC
Opcode_D8:
	;ret c
	ex af,af'
	jr c,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_F8:
	;ret m
	ex af,af'
	jp m,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_D0:
	;ret nc
	ex af,af'
	jr nc,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_C0:
	;ret nz
	ex af,af'
	jr nz,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_F0:
	;ret p
	ex af,af'
	jp p,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_E8:
	;ret pe
	ex af,af'
	jp pe,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_E0:
	;ret po
	ex af,af'
	jp po,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_C8:
	;ret z
	ex af,af'
	jr z,Opcode_Ret
	ex af,af'
	ret		;CHANGE_ME
Opcode_DC:
	;call c,nnnn
	condCallPre
	ex af,af'
	jp c,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_FC:
	;call m,nnnn
	condCallPre
	ex af,af'
	jp m,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_D4:
	;call nc,nnnn
	condCallPre
	ex af,af'
	jr nc,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_C4:
	;call nz,nnnn
	condCallPre
	ex af,af'
	jr nz,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_F4:
	;call p,nnnn
	condCallPre
	ex af,af'
	jp p,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_EC:
	;call pe,nnnn
	condCallPre
	ex af,af'
	jp pe,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_E4:
	;call po,nnnn
	condCallPre
	ex af,af'
	jp po,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_CC:
	;call z,nnnn
	condCallPre
	ex af,af'
	jr z,Opcode_DC_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_DC_Jump:
	ex af,af'
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	push ix
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	push de
	pop ix
	jp Optimize_PC
Opcode_CD:
	;call nnnn
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,81h
	out (7),a
Opcode_Call_Interface:
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	push ix
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	push de
	pop ix
	jp Optimize_PC
Opcode_10:
	;djnz nn
	inc ix
	inc iy
	exx
	dec b
	exx
	ret z		;CHANGE_ME
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add ix,de
	jp Optimize_PC
Opcode_E9:
	;jp (hl)
	exx
	push hl
	pop ix
	exx
	jp Optimize_PC
Opcode_18:
	;jr nn
	inc ix
	inc iy
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add ix,de
	jp Optimize_PC
Opcode_28:
	;jr z
	jrCond z
Opcode_20:
	;jr nz,nn
	jrCond nz
Opcode_30:
	;jr nc,nn
	jrCond nc
Opcode_38:
	;jr c,nn
	jrCond c
Opcode_38_Jump:
	ex af,af'
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add ix,de
	jp Optimize_PC
Opcode_C3:
	;jp nnnn
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,81h
	out (7),a
	push de
	pop ix
	jp Optimize_PC
Opcode_DA:
	;jp c,nnnn
	condJPPre
	ex af,af'
	jr c,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_FA:
	;jp m,nnnn
	condJPPre
	ex af,af'
	jp m,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_D2:
	;jp nc,nnnn
	condJPPre
	ex af,af'
	jr nc,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_C2:
	;jp nz,nnnn
	condJPPre
	ex af,af'
	jr nz,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_C2_Jump:
	ex af,af'
	push de
	pop ix
	jp Optimize_PC
Opcode_F2:
	;jp p,nnnn
	condJPPre
	ex af,af'
	jp p,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_EA:
	;jp pe,nnnn
	condJPPre
	ex af,af'
	jp pe,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_E2:
	;jp po,nnnn
	condJPPre
	ex af,af'
	jp po,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
Opcode_CA:
	;jp z,nnnn
	condJPPre
	ex af,af'
	jr z,Opcode_C2_Jump
	ex af,af'
	ret		;CHANGE_ME
