opOnIY MACRO op
	call FD_LoadRFromIY
	ld b,a
	ex af,af'
	&op b
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
logicalIY MACRO iyop
	ex de,hl
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	&iyop (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
bitIY MACRO bitn
	ex de,hl
	bit 7,h				;8
	jr nz,$_RAM	;12/7
	bit 6,h				;8
	jr z,$_0	;12/7
	set 7,h				;8
	res 6,h				;8
	ld a,(currompage)	;13
	out (7),a			;11
	ex af,af'			;4
	bit &bitn,(hl)			;7
	ex af,af'			;4
	ld a,81h				;7
	out (7),a			;11
	ret		;CHANGE_ME
$_0:
	set 7,h				;4
	ld a,(basepage)	;13
	out (7),a			;11
	ex af,af'			;4
	bit &bitn,(hl)			;7
	ex af,af'			;4
	ld a,81h				;7
	out (7),a			;11
	ret		;CHANGE_ME
$_RAM:
	ld a,(currentRAMPage)	;13
	out (7),a			;11
	ex af,af'			;4
	bit &bitn,(hl)			;7
	ex af,af'			;4
	ld a,81h				;7
	out (7),a			;11
	ret		;CHANGE_ME
	.ENDM
resBitIY MACRO bitn
	ex de,hl
	ld a,(currentRAMPage)
	out (7),a
	res &bitn,(hl)
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
setBitIY MACRO bitn
	ex de,hl
	ld a,(currentRAMPage)
	out (7),a
	set &bitn,(hl)
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
setupIYPointer MACRO
	ld hl,(registerIY)
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	.ENDM
ldRFromIY MACRO reg,exxtype
	setupIYPointer
	bit 7,h
	jr nz,$_RAM
	bit 6,h
	jr z,$_0
	set 7,h
	res 6,h
	ld a,(currompage)
	out (7),a
	IF &exxtype==0
		ex af,af'
		ld a,(hl)
		ex af,af'
	ELSE
		ld a,(hl)
		exx
		ld &reg,a
		exx
	ENDIF
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
$_0:
	set 7,h
	ld a,(basepage)
	out (7),a
	IF &exxtype==0
		ex af,af'
		ld a,(hl)
		ex af,af'
	ELSE
		ld a,(hl)
		exx
		ld &reg,a
		exx
	ENDIF
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
$_RAM:
	ld a,(currentRAMPage)
	out (7),a
	IF &exxtype==0
		ex af,af'
		ld a,(hl)
		ex af,af'
	ELSE
		ld a,(hl)
		exx
		ld &reg,a
		exx
	ENDIF
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
Opcode_FD:
	inc ix
	inc iy
	ld h,4Ah >> 1
	ld l,e
	add hl,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
FD_E9:
	;jp (iy)
	ld ix,(registerIY)
	jp Optimize_PC
FD_CB:
	ld a,i
	out (7),a
	ld sp,iy
	pop de
	ld sp,speedstack
	ld a,81h
	out (7),a
	inc ix
	inc ix
	inc iy
	inc iy
	ld hl,(registerIY)
	ld c,d
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ex de,hl
	ld hl,Opcode_FD_CB_Table
	ld a,c
	srl a
	srl a
	srl a
	srl a
	adc a,a ;x2
	add a,a
	ld c,a
	ld b,0
	add hl,bc
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	;IY index location in DE
	jp (hl)
Opcode_FD_CB_Table:
	DW FD_CB_06
	DW FD_CB_0E
	DW FD_CB_16
	DW FD_CB_1E
	DW FD_CB_26
	DW FD_CB_2E
	DW FD_CB_36
	DW FD_CB_3E
	DW FD_CB_46
	DW FD_CB_4E
	DW FD_CB_56
	DW FD_CB_5E
	DW FD_CB_66
	DW FD_CB_6E
	DW FD_CB_76
	DW FD_CB_7E
	DW FD_CB_86
	DW FD_CB_8E
	DW FD_CB_96
	DW FD_CB_9E
	DW FD_CB_A6
	DW FD_CB_AE
	DW FD_CB_B6
	DW FD_CB_BE
	DW FD_CB_C6
	DW FD_CB_CE
	DW FD_CB_D6
	DW FD_CB_DE
	DW FD_CB_E6
	DW FD_CB_EE
	DW FD_CB_F6
	DW FD_CB_FE
FD_CB_BE:
	;res 7,(iy+d)
	resBitIY 7
FD_CB_B6:
	;res 6,(iy+d)
	resBitIY 6
FD_CB_AE:
	;res 5,(iy+d)
	resBitIY 5
FD_CB_A6:
	;res 4,(iy+d)
	resBitIY 4
FD_CB_9E:
	;res 3,(iy+d)
	resBitIY 3
FD_CB_96:
	;res 2,(iy+d)
	resBitIY 2
FD_CB_8E:
	;res 1,(iy+d)
	resBitIY 1
FD_CB_86:
	;res 0,(iy+d)
	resBitIY 0
FD_CB_FE:
	;set 7,(iy+d)
	setBitIY 7
FD_CB_F6:
	;set 6,(iy+d)
	setBitIY 6
FD_CB_EE:
	;set 5,(iy+d)
	setBitIY 5
FD_CB_E6:
	;set 4,(iy+d)
	setBitIY 4
FD_CB_DE:
	;set 3,(iy+d)
	setBitIY 3
FD_CB_D6:
	;set 2,(iy+d)
	setBitIY 2
FD_CB_CE:
	;set 1,(iy+d)
	setBitIY 1
FD_CB_C6:
	;set 0,(iy+d)
	setBitIY 0
FD_CB_7E:
	;bit 7,(iy+d)
	bitIY 7
FD_CB_76:
	;bit 6,(iy+d)
	bitIY 6
FD_CB_6E:
	;bit 5,(iy+d)
	bitIY 5
FD_CB_66:
	;bit 4,(iy+d)
	bitIY 4
FD_CB_5E:
	;bit 3,(iy+d)
	bitIY 3
FD_CB_56:
	;bit 2,(iy+d)
	bitIY 2
FD_CB_4E:
	;bit 1,(iy+d)
	bitIY 1
FD_CB_46:
	;bit 0,(iy+d)
	bitIY 0
FD_CB_3E:
	;srl (iy)
	logicalIY srl
FD_CB_36:
	;sll (iy)
	ex de,hl
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	sla (hl)
	set 0,(hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
FD_CB_2E:
	;sra (iy)
	logicalIY sra
FD_CB_26:
	;sla (iy)
	logicalIY sla
FD_CB_1E:
	;rr (iy)
	logicalIY rr
FD_CB_0E:
	;rrc (iy)
	logicalIY rrc
FD_CB_16:
	;rl (iy)
	logicalIY rl
FD_CB_06:
	;rlc (iy+d)
	logicalIY rlc
FD_2B:
	;dec iy
	ld hl,(registerIY)
	dec hl
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_23:
	;inc iy
	ld hl,(registerIY)
	inc hl
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_09:
	;add iy,bc
	ld hl,(registerIY)
	exx
	push bc
	exx
	pop bc
	ex af,af'
	add hl,bc
	ex af,af'
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_19:
	;add iy,de
	ld hl,(registerIY)
	exx
	push de
	exx
	pop de
	ex af,af'
	add hl,de
	ex af,af'
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_29:
	;add iy,iy
	ld hl,(registerIY)
	ex af,af'
	add hl,hl
	ex af,af'
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_39:
	;add iy,sp
	ld hl,(registerIY)
	ld bc,(registerSP)
	ex af,af'
	add hl,bc
	ex af,af'
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_35:
	;dec (iy+d)
	call Fetch_Byte_PC
	ld hl,(registerIY)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	dec (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
FD_34:
	;inc (iy+d)
	call Fetch_Byte_PC
	ld hl,(registerIY)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	inc (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
FD_BE:
	;cp (iy+d)
	opOnIY cp
FD_AE:
	;xor (iy+d)
	opOnIY xor
FD_B6:
	;or (iy+d)
	opOnIY or
FD_A6:
	;and (iy+d)
	opOnIY and
FD_9E:
	;sbc a,(iy+d)
	opOnIY sbc
FD_96:
	;sub (iy+d)
	opOnIY sub
FD_8E:
	;adc a,(iy+d)
	opOnIY adc
FD_86:
	;add a,(iy+d)
	opOnIY add
FD_E3:
	;ex (sp),iy
	ld sp,(registerSP)
	ld hl,(registerIY)
	ld a,(currentRAMPage)
	out (7),a
	ex (sp),hl
	ld a,81h
	out (7),a
	ld (registerIY),hl
	ld sp,speedstack
	ret		;CHANGE_ME
FD_E1:
	;pop iy
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	pop hl
	ld a,81h
	out (7),a
	ld (registerIY),hl
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
FD_E5:
	;push iy
	ld sp,(registerSP)
	ld hl,(registerIY)
	ld a,(currentRAMPage)
	out (7),a
	push hl
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
FD_F9:
	;ld sp,iy
	ld hl,(registerIY)
	ld (registerSP),hl
	ret		;CHANGE_ME
FD_22:
	;ld (nnnn),iy
	ld de,(registerIY)
	inc ix
	inc ix
	ld a,(currentRAMPage)
	ld c,a
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,c
	out (7),a
	ld (hl),e
	inc hl
	ld (hl),d
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
FD_2A:
	;ld iy,(nnnn)
	call Fetch_Word_PC
	call Fetch_Byte_HL
	ld a,e
	ld (registerIY),a
	inc hl
	call Fetch_Byte_HL
	ld a,e
	ld (registerIY+1),a
	ret		;CHANGE_ME
FD_21:
	;ld iy,nnnn
	inc ix
	inc ix
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,81h
	out (7),a
	ld (registerIY),hl
	ret		;CHANGE_ME
FD_7E:
	;ld a,(iy+d)
	ldRFromIY a,0
FD_4E:
	;ld c,(iy+d)
	ldRFromIY c,1
FD_46:
	;ld b,(iy+d)
	ldRFromIY b,1
FD_56:
	;ld d,(iy+d)
	ldRFromIY d,1
FD_5E:
	;ld e,(iy+d)
	ldRFromIY e,1
FD_66:
	;ld h,(iy+d)
	ldRFromIY h,1
FD_6E:
	;ld l,(iy+d)
	ldRFromIY l,1
FD_77:
	ex af,af'
	ld c,a
	ex af,af'
	jp FD_WriteToIY
FD_70:
	exx
	ld a,b
	exx
	ld c,a
	jp FD_WriteToIY
FD_71:
	exx
	ld a,c
	exx
	ld c,a
	jp FD_WriteToIY
FD_72:
	exx
	ld a,d
	exx
	ld c,a
	jp FD_WriteToIY
FD_73:
	exx
	ld a,e
	exx
	ld c,a
	jp FD_WriteToIY
FD_74:
	exx
	ld a,h
	exx
	ld c,a
	jp FD_WriteToIY
FD_75:
	exx
	ld a,l
	exx
	ld c,a
	jp FD_WriteToIY
FD_36:
	;ld (iy+n),nn
	call FD_FindIY
	inc ix
	inc iy
	ld a,(currentRAMPage)
	ld d,a
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,d
	out (7),a
	ld (hl),e
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
FD_LoadRFromIY:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld hl,(registerIY)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	bit 7,h				;8
	jr nz,DD_LoadRFromIY_RAM	;12/7
	bit 6,h				;8
	jr z,DD_LoadRFromIY_0	;12/7
	push hl				;11
	set 7,h				;8
	res 6,h				;8
	ld a,(currompage)	;13
	out (7),a			;11
	ld e,(hl)			;7
	ld a,81h				;7
	out (7),a			;11
	pop hl				;11
	ld a,e
	ret		;CHANGE_ME
DD_LoadRFromIY_0:
	set 7,h				;4
	ld a,(basepage)	;13
	out (7),a			;11
	ld e,(hl)			;7
	res 7,h
	ld a,81h				;7
	out (7),a			;11
	ld a,e
	ret		;CHANGE_ME
DD_LoadRFromIY_RAM:
	ld a,(currentRAMPage)	;13
	out (7),a			;11
	ld e,(hl)			;7
	ld a,81h				;7
	out (7),a			;11
	ld a,e
	ret		;CHANGE_ME
FD_WriteToIY:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld hl,(registerIY)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ld a,(currentRAMPage)
	out (7),a
	ld (hl),c
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
FD_FindIY:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ld hl,(registerIY)
	ld a,e
	add a,a
	sbc a,a
	ld d,a
	add hl,de
	ret		;CHANGE_ME
FD_0:
FD_1:	
FD_2:	
FD_3:	
FD_4:	
FD_5:	
FD_6:	
FD_7:	
FD_8:	
FD_A:	
FD_B:	
FD_C:	
FD_D:	
FD_E:	
FD_F:	
FD_10:	
FD_11:	
FD_12:
	
FD_13:
	
FD_14:
	
FD_15:
	
FD_16:
	
FD_17:
	
FD_18:
	
FD_20:
	
FD_24:
	
FD_25:
	
FD_26:
	
FD_27:
	
FD_28:
	
FD_2C:
	
FD_2D:
	
FD_2E:
	
FD_2F:
	
FD_30:
	
FD_31:
	
FD_32:
	
FD_33:
	
FD_37:
	
FD_38:
	
FD_3A:
	
FD_3B:
	
FD_3C:
	
FD_3D:
	
FD_3E:
	
FD_3F:
	
FD_40:
	
FD_41:
	
FD_42:
	
FD_43:
	
FD_44:
	
FD_45:
	
FD_47:
	
FD_48:
	
FD_49:
	
FD_4A:
	
FD_4B:
	
FD_4C:
	
FD_4D:
	
FD_4F:
	
FD_50:
	
FD_51:
	
FD_52:
	
FD_53:
	
FD_54:
	
FD_55:
	
FD_57:
	
FD_58:
	
FD_59:
	
FD_5A:
	
FD_5B:
	
FD_5C:
	
FD_5D:
	
FD_5F:
	
FD_60:
	
FD_61:
	
FD_62:
	
FD_63:
	
FD_64:	
FD_65:	
FD_67:	
FD_68:	
FD_69:	
FD_6A:	
FD_6B:	
FD_6C:	
FD_6D:	
FD_6F:	
FD_78:	
FD_79:	
FD_7A:	
FD_7B:	
FD_7C:	
FD_7D:	
FD_7F:	
FD_80:	
FD_81:	
FD_82:	
FD_83:	
FD_84:	
FD_85:	
FD_87:	
FD_88:	
FD_89:	
FD_8A:	
FD_8B:	
FD_8C:
FD_8D:
FD_8F:
FD_90:
FD_91:	
FD_92:	
FD_93:	
FD_94:	
FD_95:	
FD_97:	
FD_98:	
FD_99:	
FD_9A:	
FD_9B:	
FD_9C:	
FD_9D:	
FD_9F:	
FD_A0:	
FD_A1:	
FD_A2:	
FD_A3:	
FD_A4:	
FD_A5:	
FD_A7:	
FD_A8:	
FD_A9:	
FD_AA:	
FD_AB:	
FD_AC:	
FD_AD:	
FD_AF:	
FD_B0:	
FD_B1:	
FD_B2:	
FD_B3:	
FD_B4:	
FD_B5:	
FD_B7:	
FD_B8:	
FD_B9:	
FD_BA:	
FD_BB:	
FD_BC:	
FD_BD:	
FD_BF:	
FD_C0:	
FD_C1:	
FD_C2:	
FD_C3:	
FD_C4:	
FD_C5:	
FD_C6:	
FD_C7:	
FD_C8:	
FD_C9:	
FD_CA:	
FD_CC:	
FD_CD:	
FD_CE:	
FD_CF:	
FD_D0:	
FD_D1:	
FD_D2:	
FD_D3:	
FD_D4:	
FD_D5:	
FD_D6:	
FD_D7:	
FD_D8:	
FD_D9:	
FD_DA:	
FD_DB:	
FD_DC:	
FD_DD:	
FD_DE:	
FD_DF:	
FD_E0:	
FD_E2:	
FD_E4:	
FD_E6:	
FD_E7:	
FD_E8:	
FD_EA:	
FD_EB:	
FD_EC:	
FD_ED:	
FD_EE:	
FD_EF:	
FD_F0:	
FD_F1:	
FD_F2:	
FD_F3:	
FD_F4:	
FD_F5:	
FD_F6:	
FD_F7:	
FD_F8:	
FD_FA:	
FD_FB:	
FD_FC:	
FD_FD:	
FD_FE:	
FD_FF:	
FD_1A:	
FD_1B:	
FD_1C:	
FD_1D:	
FD_1E:
FD_1F:
FD_76:
	call Debug
	ret
