rotationA MACRO op
	ex af,af'
	&op a
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
rotationHL MACRO op
	ld a,(currentRAMPage)
	out (7),a
	exx
	ex af,af'
	&op (hl)
	ex af,af'
	exx
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
sllM MACRO reg
	exx
	ex af,af'
	sla &reg
	set 0,&reg
	ex af,af'
	exx
	ret		;CHANGE_ME
	.ENDM
bitn8r MACRO bitn,reg
	exx
	ex af,af'
	bit &bitn,&reg
	ex af,af'
	exx
	ret		;CHANGE_ME
	.ENDM
bitnHL MACRO bitn
	exx
	push hl
	exx
	pop hl
	call Fetch_Byte_HL
	ex af,af'
	bit &bitn,e
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
setHL MACRO bitn
	ld a,(currentRAMPage)
	out (7),a
	exx
	set &bitn,(hl)
	exx
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
resbit MACRO bitn,reg
	exx
	res &bitn,&reg
	exx
	ret		;CHANGE_ME
	.ENDM
setbit MACRO bitn,reg
	exx
	set &bitn,&reg
	exx
	ret		;CHANGE_ME
	.ENDM
resHL MACRO bitn
	ld a,(currentRAMPage)
	out (7),a
	exx
	res &bitn,(hl)
	exx
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
Opcode_CB:
	inc ix
	inc iy
	ld l,e
	ld h,44h >> 1
	add hl,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	jp (hl)
CB_40:
	;bit 0,b
	bitn8r 0,b
CB_41:
	;bit 0,c
	bitn8r 0,c
CB_42:
	;bit 0,d
	bitn8r 0,d
CB_43:
	;bit 0,e
	bitn8r 0,e
CB_44:
	;bit 0,h
	bitn8r 0,h
CB_45:
	;bit 0,l
	bitn8r 0,l
CB_46:
	;bit 0,(hl)
	bitnHL 0
CB_47:
	;bit 0,a
	bitn8r 0,a
CB_48:
	;bit 1,b
	bitn8r 1,b
CB_49:
	;bit 1,c
	bitn8r 1,c
CB_4A:
	;bit 1,d
	bitn8r 1,d
CB_4B:
	;bit 1,e
	bitn8r 1,e
CB_4C:
	;bit 1,h
	bitn8r 1,h
CB_4D:
	;bit 1,l
	bitn8r 1,l
CB_4E:
	;bit 1,(hl)
	bitnHL 1
CB_4F:
	;bit 1,a
	bitn8r 1,a
CB_50:
	;bit 2,b
	bitn8r 2,b
CB_51:
	;bit 2,c
	bitn8r 2,c
CB_52:
	;bit 2,d
	bitn8r 2,d
CB_53:
	;bit 2,e
	bitn8r 2,e
CB_54:
	;bit 2,h
	bitn8r 2,h
CB_55:
	;bit 2,l
	bitn8r 2,l
CB_56:
	;bit 2,(hl)
	bitnHL 2
CB_57:
	;bit 2,a
	bitn8r 2,a
CB_58:
	;bit 3,b
	bitn8r 3,b
CB_59:
	;bit 3,c
	bitn8r 3,c
CB_5A:
	;bit 3,d
	bitn8r 3,d
CB_5B:
	;bit 3,e
	bitn8r 3,e
CB_5C:
	;bit 3,h
	bitn8r 3,h
CB_5D:
	;bit 3,l
	bitn8r 3,l
CB_5E:
	;bit 3,(hl)
	bitnHL 3
CB_5F:
	;bit 3,a
	bitn8r 3,a
CB_60:
	;bit 4,b
	bitn8r 4,b
CB_61:
	;bit 4,c
	bitn8r 4,c
CB_62:
	;bit 4,d
	bitn8r 4,d
CB_63:
	;bit 4,e
	bitn8r 4,e
CB_64:
	;bit 4,h
	bitn8r 4,h
CB_65:
	;bit 4,l
	bitn8r 4,l
CB_66:
	;bit 4,(hl)
	bitnHL 4
CB_67:
	;bit 4,a
	bitn8r 4,a
CB_68:
	;bit 5,b
	bitn8r 5,b
CB_69:
	;bit 5,c
	bitn8r 5,c
CB_6A:
	;bit 5,d
	bitn8r 5,d
CB_6B:
	;bit 5,e
	bitn8r 5,e
CB_6C:
	;bit 5,h
	bitn8r 5,h
CB_6D:
	;bit 5,l
	bitn8r 5,l
CB_6E:
	;bit 5,(hl)
	bitnHL 5
CB_6F:
	;bit 5,a
	bitn8r 5,a
CB_70:
	;bit 6,b
	bitn8r 6,b
CB_71:
	;bit 6,c
	bitn8r 6,c
CB_72:
	;bit 6,d
	bitn8r 6,d
CB_73:
	;bit 6,e
	bitn8r 6,e
CB_74:
	;bit 6,h
	bitn8r 6,h
CB_75:
	;bit 6,l
	bitn8r 6,l
CB_76:
	;bit 6,(hl)
	bitnHL 6
CB_77:
	;bit 6,a
	bitn8r 6,a
CB_78:
	;bit 7,b
	bitn8r 7,b
CB_79:
	;bit 7,c
	bitn8r 7,c
CB_7A:
	;bit 7,d
	bitn8r 7,d
CB_7B:
	;bit 7,e
	bitn8r 7,e
CB_7C:
	;bit 7,h
	bitn8r 7,h
CB_7D:
	;bit 7,l
	bitn8r 7,l
CB_7E:
	;bit 7,(hl)
	bitnHL 7
CB_7F:
	;bit 7,a
	bitn8r 7,a
CB_80:
	;res 0,b
	resbit 0,b
CB_81:
	;res 0,c
	resbit 0,c
CB_82:
	;res 0,d
	resbit 0,d
CB_83:
	;res 0,e
	resbit 0,e
CB_84:
	;res 0,h
	resbit 0,h
CB_85:
	;res 0,l
	resbit 0,l
CB_86:
	;res 0,(hl)
	resHL 0
CB_87:
	;res 0,a
	ex af,af'
	res 0,a
	ex af,af'
	ret		;CHANGE_ME
CB_88:
	;res 1,b
	resbit 1,b
CB_89:
	;res 1,c
	resbit 1,c
CB_8A:
	;res 1,d
	resbit 1,d
CB_8B:
	;res 1,e
	resbit 1,e
CB_8C:
	;res 1,h
	resbit 1,h
CB_8D:
	;res 1,l
	resbit 1,l
CB_8E:
	;res 1,(hl)
	resHL 1
CB_8F:
	;res 1,a
	ex af,af'
	res 1,a
	ex af,af'
	ret		;CHANGE_ME
CB_90:
	;res 2,b
	resbit 2,b
CB_91:
	;res 2,c
	resbit 2,c
CB_92:
	;res 2,d
	resbit 2,d
CB_93:
	;res 2,e
	resbit 2,e
CB_94:
	;res 2,h
	resbit 2,h
CB_95:
	;res 2,l
	resbit 2,l
CB_96:
	;res 2,(hl)
	resHL 2
CB_97:
	;res 2,a
	ex af,af'
	res 2,a
	ex af,af'
	ret		;CHANGE_ME
CB_98:
	;res 3,b
	resbit 3,b
CB_99:
	;res 3,c
	resbit 3,c
CB_9A:
	;res 3,d
	resbit 3,d
CB_9B:
	;res 3,e
	resbit 3,e
CB_9C:
	;res 3,h
	resbit 3,h
CB_9D:
	;res 3,l
	resbit 3,l
CB_9E:
	;res 3,(hl)
	resHL 3
CB_9F:
	;res 3,a
	ex af,af'
	res 3,a
	ex af,af'
	ret		;CHANGE_ME
CB_A0:
	;res 4,b
	resbit 4,b
CB_A1:
	;res 4,c
	resbit 4,c
CB_A2:
	;res 4,d
	resbit 4,d
CB_A3:
	;res 4,e
	resbit 4,e
CB_A4:
	;res 4,h
	resbit 4,h
CB_A5:
	;res 4,l
	resbit 4,l
CB_A6:
	;res 4,(hl)
	resHL 4
CB_A7:
	;res 4,a
	ex af,af'
	res 4,a
	ex af,af'
	ret		;CHANGE_ME
CB_A8:
	;res 5,b
	resbit 5,b
CB_A9:
	;res 5,c
	resbit 5,c
CB_AA:
	;res 5,d
	resbit 5,d
CB_AB:
	;res 5,e
	resbit 5,e
CB_AC:
	;res 5,h
	resbit 5,h
CB_AD:
	;res 5,l
	resbit 5,l
CB_AE:
	;res 5,(hl)
	resHL 5
CB_AF:
	;res 5,a
	ex af,af'
	res 5,a
	ex af,af'
	ret		;CHANGE_ME
CB_B0:
	;res 6,b
	resbit 6,b
CB_B1:
	;res 6,c
	resbit 6,c
CB_B2:
	;res 6,d
	resbit 6,d
CB_B3:
	;res 6,e
	resbit 6,e
CB_B4:
	;res 6,h
	resbit 6,h
CB_B5:
	;res 6,l
	resbit 6,l
CB_B6:
	;res 6,(hl)
	resHL 6
CB_B7:
	;res 6,a
	ex af,af'
	res 6,a
	ex af,af'
	ret		;CHANGE_ME
CB_B8:
	;res 7,b
	resbit 7,b
CB_B9:
	;res 7,c
	resbit 7,c
CB_BA:
	;res 7,d
	resbit 7,d
CB_BB:
	;res 7,e
	resbit 7,e
CB_BC:
	;res 7,h
	resbit 7,h
CB_BD:
	;res 7,l
	resbit 7,l
CB_BE:
	;res 7,(hl)
	resHL 7
CB_BF:
	;res 7,a
	ex af,af'
	res 7,a
	ex af,af'
	ret		;CHANGE_ME
CB_C0:
	;set 0,b
	setbit 0,b
CB_C1:
	;set 0,c
	setbit 0,c
CB_C2:
	;set 0,d
	setbit 0,d
CB_C3:
	;set 0,e
	setbit 0,e
CB_C4:
	;set 0,h
	setbit 0,h
CB_C5:
	;set 0,l
	setbit 0,l
CB_C6:
	;set 0,(hl)
	setHL 0
CB_C7:
	;set 0,a
	ex af,af'
	set 0,a
	ex af,af'
	ret		;CHANGE_ME
CB_C8:
	;set 1,b
	setbit 1,b
CB_C9:
	;set 1,c
	setbit 1,c
CB_CA:
	;set 1,d
	setbit 1,d
CB_CB:
	;set 1,e
	setbit 1,e
CB_CC:
	;set 1,h
	setbit 1,h
CB_CD:
	;set 1,l
	setbit 1,l
CB_CE:
	;set 1,(hl)
	setHL 1
CB_CF:
	;set 1,a
	ex af,af'
	set 1,a
	ex af,af'
	ret		;CHANGE_ME
CB_D0:
	;set 2,b
	setbit 2,b
CB_D1:
	;set 2,c
	setbit 2,c
CB_D2:
	;set 2,d
	setbit 2,d
CB_D3:
	;set 2,e
	setbit 2,e
CB_D4:
	;set 2,h
	setbit 2,h
CB_D5:
	;set 2,l
	setbit 2,l
CB_D6:
	;set 2,(hl)
	setHL 2
CB_D7:
	;set 2,a
	ex af,af'
	set 2,a
	ex af,af'
	ret		;CHANGE_ME
CB_D8:
	;set 3,b
	setbit 3,b
CB_D9:
	;set 3,c
	setbit 3,c
CB_DA:
	;set 3,d
	setbit 3,d
CB_DB:
	;set 3,e
	setbit 3,e
CB_DC:
	;set 3,h
	setbit 3,h
CB_DD:
	;set 3,l
	setbit 3,l
CB_DE:
	;set 3,(hl)
	setHL 3
CB_DF:
	;set 3,a
	ex af,af'
	set 3,a
	ex af,af'
	ret		;CHANGE_ME
CB_E0:
	;set 4,b
	setbit 4,b
CB_E1:
	;set 4,c
	setbit 4,c
CB_E2:
	;set 4,d
	setbit 4,d
CB_E3:
	;set 4,e
	setbit 4,e
CB_E4:
	;set 4,h
	setbit 4,h
CB_E5:
	;set 4,l
	setbit 4,l
CB_E6:
	;set 4,(hl)
	setHL 4
CB_E7:
	;set 4,a
	ex af,af'
	set 4,a
	ex af,af'
	ret		;CHANGE_ME
CB_E8:
	;set 5,b
	setbit 5,b
CB_E9:
	;set 5,c
	setbit 5,c
CB_EA:
	;set 5,d
	setbit 5,d
CB_EB:
	;set 5,e
	setbit 5,e
CB_EC:
	;set 5,h
	setbit 5,h
CB_ED:
	;set 5,l
	setbit 5,l
CB_EE:
	;set 5,(hl)
	setHL 5
CB_EF:
	;set 5,a
	ex af,af'
	set 5,a
	ex af,af'
	ret		;CHANGE_ME
CB_F0:
	;set 6,b
	setbit 6,b
CB_F1:
	;set 6,c
	setbit 6,c
CB_F2:
	;set 6,d
	setbit 6,d
CB_F3:
	;set 6,e
	setbit 6,e
CB_F4:
	;set 6,h
	setbit 6,h
CB_F5:
	;set 6,l
	setbit 6,l
CB_F6:
	;set 6,(hl)
	setHL 6
CB_F7:
	;set 6,a
	ex af,af'
	set 6,a
	ex af,af'
	ret		;CHANGE_ME
CB_F8:
	;set 7,b
	setbit 7,b
CB_F9:
	;set 7,c
	setbit 7,c
CB_FA:
	;set 7,d
	setbit 7,d
CB_FB:
	;set 7,e
	setbit 7,e
CB_FC:
	;set 7,h
	setbit 7,h
CB_FD:
	;bit 7,l
	setbit 7,l
CB_FE:
	;set 7,(hl)
	setHL 7
CB_FF:
	;set 7,a
	ex af,af'
	set 7,a
	ex af,af'
	ret		;CHANGE_ME
CB_3F:
	;srl a
	rotationA srl
CB_38:
	;srl b
	generalOpSpaceReg srl,b
CB_39:
	;srl c
	generalOpSpaceReg srl,c
CB_3A:
	;srl d
	generalOpSpaceReg srl,d
CB_3B:
	;srl e
	generalOpSpaceReg srl,e
CB_3C:
	;srl h
	generalOpSpaceReg srl,h
CB_3D:
	;srl l
	generalOpSpaceReg srl,l
CB_3E:
	;srl (hl)
	rotationHL srl
CB_2F:
	;sra a
	rotationA sra
CB_28:
	;sra b
	generalOpSpaceReg sra,b
CB_29:
	;sra c
	generalOpSpaceReg sra,c
CB_2A:
	;sra d
	generalOpSpaceReg sra,d
CB_2B:
	;sra e
	generalOpSpaceReg sra,e
CB_2C:
	;sra h
	generalOpSpaceReg sra,h
CB_2D:
	;sra l
	generalOpSpaceReg sra,l
CB_2E:
	;sra (hl)
	rotationHL sra
CB_20:
	;sla b
	generalOpSpaceReg sla,b
CB_27:
	;sla a
	rotationA sla
CB_21:
	;sla c
	generalOpSpaceReg sla,c
CB_22:
	;sla d
	generalOpSpaceReg sla,d
CB_23:
	;sla e
	generalOpSpaceReg sla,e
CB_24:
	;sla h
	generalOpSpaceReg sla,h
CB_25:
	;sla l
	generalOpSpaceReg sla,l
CB_26:
	;sla (hl)
	rotationHL sla
CB_1F:
	;rr a
	rotationA rr
CB_18:
	;rr b
	generalOpSpaceReg rr,b
CB_19:
	;rr c
	generalOpSpaceReg rr,c
CB_1A:
	;rr d
	generalOpSpaceReg rr,d
CB_1B:
	;rr e
	generalOpSpaceReg rr,e
CB_1C:
	;rr h
	generalOpSpaceReg rr,h
CB_1D:
	;rr l
	generalOpSpaceReg rr,l
CB_1E:
	;rr (hl)
	rotationHL rr
CB_0F:
	;rrc a
	rotationA rrc
CB_08:
	;rrc b
	generalOpSpaceReg rrc,b
CB_09:
	;rrc c
	generalOpSpaceReg rrc,c
CB_0A:
	;rrc d
	generalOpSpaceReg rrc,d
CB_0B:
	;rrc e
	generalOpSpaceReg rrc,e
CB_0C:
	;rrc h
	generalOpSpaceReg rrc,h
CB_0D:
	;rrc l
	generalOpSpaceReg rrc,l
CB_0E:
	;rrc (hl)
	rotationHL rrc
CB_16:
	;rl (hl)
	rotationHL rl
CB_17:
	;rl a
	rotationA rl
CB_10:
	;rl b
	generalOpSpaceReg rl,b
CB_11:
	;rl c
	generalOpSpaceReg rl,c
CB_12:
	;rl d
	generalOpSpaceReg rl,d
CB_13:
	;rl e
	generalOpSpaceReg rl,e
CB_14:
	;rl h
	generalOpSpaceReg rl,h
CB_15:
	;rl l
	generalOpSpaceReg rl,l
CB_06:
	;rlc (hl)
	rotationHL rlc
CB_07:
	;rlc a
	rotationA rlc
CB_00:
	;rlc b
	generalOpSpaceReg rlc,b
CB_01:
	;rlc c
	generalOpSpaceReg rlc,c
CB_02:
	;rlc d
	generalOpSpaceReg rlc,d
CB_03:
	;rlc e
	generalOpSpaceReg rlc,e
CB_04:
	;rlc h
	generalOpSpaceReg rlc,h
CB_05:
	;rlc l
	generalOpSpaceReg rlc,l
Opcode_07:
	;rlca
	ex af,af'
	rlca
	ex af,af'
	ret		;CHANGE_ME
Opcode_17:
	;rla
	ex af,af'
	rla
	ex af,af'
	ret		;CHANGE_ME
Opcode_0F:
	;rrca
	ex af,af'
	rrca
	ex af,af'
	ret		;CHANGE_ME
Opcode_1F:
	;rra
	ex af,af'
	rra
	ex af,af'
	ret		;CHANGE_ME
CB_30:
	;sll b
	sllM b
CB_31:
	;sll c
	sllM c
CB_32:
	;sll d
	sllM d
CB_33:
	;sll e
	sllM e
CB_34:
	;sll h
	sllM h
CB_35:
	;sll l
	sllM l
CB_36:
	;sll (hl)
	ld a,(currentRAMPage)
	out (7),a
	exx
	ex af,af'
	sla (hl)
	set 0,(hl)
	ex af,af'
	exx
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
CB_37:
	;sll a
	ex af,af'
	sla a
	set 0,a
	ex af,af'
	ret		;CHANGE_ME
