Opcode_22:
	;ld (nnnn),hl
	exx
	push hl
	exx
	ld l,e
	pop de
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,(currentRAMPage)
	ld c,a
	ld a,i
	out (7),a
	ld h,(iy-1)
	ld a,c
	out (7),a
	ld (hl),e
	inc hl
	ld (hl),d
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
Opcode_2A:
	;ld hl,(nnnn)
	load16FromNNNN hl
Opcode_01:
	;ld bc,nnnn
	load16R b,c
Opcode_11:
	;ld de,nnnn
	load16R d,e
Opcode_21:
	;ld hl,nnnn
	load16R h,l
Opcode_31:
	;ld sp,nnnn
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,81h
	out (7),a
	ld (registerSP),de
	ret		;CHANGE_ME
Opcode_32:
	;ld (nnnn),a
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,(currentRAMPage)
	ld c,a
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,c
	out (7),a
	ex af,af'
	ld (de),a
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
Opcode_3A:
	;ld a,(nnnn)
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld d,(iy-1)
	ld a,81h
	out (7),a
	bit 7,d
	jr nz,Opcode_3A_RAM
	bit 6,d
	jr z,Opcode_3A_0
	set 7,d
	res 6,d
	ld a,(currompage)
	out (7),a
	ex af,af'
	ld a,(de)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
Opcode_3A_0:
	set 7,d
	ld a,(basepage)
	out (7),a
	ex af,af'
	ld a,(de)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
Opcode_3A_RAM:
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	ld a,(de)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
Opcode_3E:
	;ld a,nn
	inc ix
	inc iy
	ex af,af'
	ld a,e
	ex af,af'
	ret		;CHANGE_ME
Opcode_06:
	;ld b,nn
	loadNin8R b
Opcode_0E:
	;ld c,nn
	loadNin8R c
Opcode_16:
	;ld d,nn
	loadNin8R d
Opcode_1E:
	;ld e,nn
	loadNin8R e
Opcode_26:
	;ld h,nn
	loadNin8R h
Opcode_2E:
	;ld l,nn
	loadNin8R l
