Opcode_FE:
	;cp nn
	opcodeAonNN cp
Opcode_F6:
	;or nn
	opcodeAonNN or
Opcode_EE:
	;xor nn
	opcodeAonNN xor
Opcode_0B:
	;dec bc
	generalOpSpaceReg dec,bc
Opcode_1B:
	;dec de
	generalOpSpaceReg dec,de
Opcode_2B:
	;dec hl
	generalOpSpaceReg dec,hl
Opcode_3B:
	;dec sp
	ld hl,(registerSP)
	dec hl
	ld (registerSP),hl
	ret		;CHANGE_ME
Opcode_03:
	;inc bc
	generalOpSpaceReg inc,bc
Opcode_13:
	;inc de
	generalOpSpaceReg inc,de
Opcode_23:
	;inc hl
	generalOpSpaceReg inc,hl
Opcode_33:
	;inc sp
	ld hl,(registerSP)
	inc hl
	ld (registerSP),hl
	ret		;CHANGE_ME
Opcode_3D:
	;dec a
	ex af,af'
	dec a
	ex af,af'
	ret		;CHANGE_ME
Opcode_05:
	;dec b
	generalOpSpaceReg dec,b
Opcode_0D:
	;dec c
	generalOpSpaceReg dec,c
Opcode_15:
	;dec d
	generalOpSpaceReg dec,d
Opcode_1D:
	;dec e
	generalOpSpaceReg dec,e
Opcode_25:
	;dec h
	generalOpSpaceReg dec,h
Opcode_2D:
	;dec l
	generalOpSpaceReg dec,l
Opcode_3C:
	;inc a
	ex af,af'
	inc a
	ex af,af'
	ret		;CHANGE_ME
Opcode_0C:
	;inc c
	generalOpSpaceReg inc,c
Opcode_04:
	;inc b
	generalOpSpaceReg inc,b
Opcode_14:
	;inc d
	generalOpSpaceReg inc,d
Opcode_1C:
	;inc e
	generalOpSpaceReg inc,e
Opcode_24:
	;inc h
	generalOpSpaceReg inc,h
Opcode_2C:
	;inc l
	generalOpSpaceReg inc,l
Opcode_34:
	;inc (hl)
	generalOpSpaceParenHL inc
Opcode_35:
	;dec (hl)
	generalOpSpaceParenHL dec
Opcode_BF:
	;cp a
	ex af,af'
	cp a
	ex af,af'
	ret		;CHANGE_ME
Opcode_B8:
	;cp b
	generalOpSpaceReg cp,b
Opcode_B9:
	;cp c
	generalOpSpaceReg cp,c
Opcode_BA:
	;cp d
	generalOpSpaceReg cp,d
Opcode_BB:
	;cp e
	generalOpSpaceReg cp,e
Opcode_BC:
	;cp h
	generalOpSpaceReg cp,h
Opcode_BD:
	;cp l
	generalOpSpaceReg cp,l
Opcode_BE:
	;cp (hl)
	opAHL cp
Opcode_AF:
	;xor a
	ex af,af'
	xor a
	ex af,af'
	ret		;CHANGE_ME
Opcode_A8:
	;xor b
	generalOpSpaceReg xor,b
Opcode_A9:
	;xor c
	generalOpSpaceReg xor,c
Opcode_AA:
	;xor d
	generalOpSpaceReg xor,d
Opcode_AB:
	;xor e
	generalOpSpaceReg xor,e
Opcode_AC:
	;xor h
	generalOpSpaceReg xor,h
Opcode_AD:
	;xor l
	generalOpSpaceReg xor,l
Opcode_AE:
	;xor (hl)
	opAHL xor
Opcode_B7:
	;or a
	ex af,af'
	or a
	ex af,af'
	ret		;CHANGE_ME
Opcode_B0:
	;or b
	generalOpSpaceReg or,b
Opcode_B1:
	;or c
	generalOpSpaceReg or,c
Opcode_B2:
	;or d
	generalOpSpaceReg or,d
Opcode_B3:
	;or e
	generalOpSpaceReg or,e
Opcode_B4:
	;or h
	generalOpSpaceReg or,h
Opcode_B5:
	;or l
	generalOpSpaceReg or,l
Opcode_B6:
	;or (hl)
	opAHL or
Opcode_E6:
	;and nn
	opcodeAonNN and
Opcode_A7:
	;and a
	ex af,af'
	and a
	ex af,af'
	ret		;CHANGE_ME
Opcode_A0:
	;and b
	generalOpSpaceReg and,b
Opcode_A1:
	;and c
	generalOpSpaceReg and,c
Opcode_A2:
	;and d
	generalOpSpaceReg and,d
Opcode_A3:
	;and e
	generalOpSpaceReg and,e
Opcode_A4:
	;and h
	generalOpSpaceReg and,h
Opcode_A5:
	;and l
	generalOpSpaceReg and,l
Opcode_A6:
	;and (hl)
	opAHL and
