opcodeA MACRO op
	ex af,af'
	&op
	ex af,af'
	ret		;CHANGEM
	.ENDM
opcodeACommaOneParam MACRO op,reg
	exx
	ex af,af'
	&op a,&reg
	ex af,af'
	exx
	ret		;CHANGE_ME
	.ENDM
opcodeACommaA MACRO op
	ex af,af'
	&op a,a
	ex af,af'
	ret
	.ENDM
opcodeAonNN MACRO op
	inc ix
	inc iy
	ex af,af'
	&op a,e
	ex af,af'
	ret		;CHANGE_ME
	.ENDM
generalOpSpaceReg MACRO op,reg
	ex af,af'
	exx
	&op &reg
	exx
	ex af,af'
	ret
	.ENDM
load8R MACRO dest,src
	if "&dest"=="a"||"&src"=="a"
		ex af,af'
	endif
	exx
	ld &dest,&src
	exx
	if "&dest"=="a"||"&src"=="a"
		ex af,af'
	endif
	ret		;CHANGE_ME
	.ENDM
loadNin8R MACRO reg
	inc ix
	inc iy
	ld a,e
	exx
	ld &reg,a
	exx
	ret		;CHANGE_ME
	.ENDM
loadMemRegFromR MACRO reg,src
	ld a,(currentRAMPage)
	out (7),a
	if "&src"=="a"
		ex af,af'
	endif
	exx
	ld (&reg),&src
	exx
	if "&src"=="a"
		ex af,af'
	endif
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
loadRFrom16Reg MACRO dest,reg1,reg2
	exx					;4
	bit 7,&reg1				;8
	jr nz,$_RAM	;12/7
	bit 6,&reg1			;8
	jr z,$_0	;12/7
	set 7,&reg1			;8
	res 6,&reg1				;8
	ld a,(currompage)	;13
	out (7),a			;11
	if ("&dest"=="a")
		ex af,af'
	endif
	if (("&dest"=="h" || "&dest"=="l")&&("&reg1"=="h" && "&reg2"=="l"))
		ld a,(&reg1&&reg2)
		set 6,&reg1
		res 7,&reg1
		ld &dest,a
		exx
	else
		ld &dest,(&reg1&&reg2)			;7
		set 6,&reg1
		res 7,&reg1
		exx
	endif
	if ("&dest"=="a")
		ex af,af'
	endif
	ld a,81h				;7
	out (7),a			;11
	ret		;CHANGE_ME
$_0:
	set 7,&reg1				;4
	ld a,(basepage)	;13
	out (7),a			;11
	if ("&dest"=="a")
		ex af,af'
	endif
	if (("&dest"=="h" || "&dest"=="l")&&("&reg1"=="h" && "&reg2"=="l"))
		ld a,(&reg1&&reg2)
		res 7,&reg1
		ld &dest,a
		exx
	else
		ld &dest,(&reg1&&reg2)	;7
		res 7,&reg1
		exx
	endif
	if ("&dest"=="a")
		ex af,af'
	endif
	ld a,81h				;7
	out (7),a			;11
	ret		;CHANGE_ME
$_RAM:
	ld a,(currentRAMPage)	;13
	out (7),a			;11
	if ("&dest"=="a")
		ex af,af'
	endif
	ld &dest,(&reg1&&reg2)	;7
	exx
	if ("&dest"=="a")
		ex af,af'
	endif
	ld a,81h				;7
	out (7),a			;11
	ret		;CHANGE_ME
	.ENDM
load16R MACRO reg1,reg2
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld a,e
	exx
	ld &reg1,(iy-1)
	ld &reg2,a
	exx
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
generalOpSpaceParenHL MACRO op
	exx
	push hl
	exx
	pop hl
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	&op (hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
pushReg MACRO reg
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	exx
	push &reg
	exx
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
	.ENDM
popReg MACRO reg
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	exx
	pop &reg
	exx
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
	.ENDM
opAHL MACRO op
	exx
	push hl
	exx
	pop hl
	bit 7,h
	jr nz,$_RAM
	bit 6,h
	jr z,$_0
	set 7,h
	res 6,h
	ld a,(currompage)
	out (7),a
	ex af,af'
	&op a,(hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
$_0:
	set 7,h
	ld a,(basepage)
	out (7),a
	ex af,af'
	&op a,(hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
$_RAM:
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	&op a,(hl)
	ex af,af'
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
opHL16 MACRO op,reg
	exx
	ex af,af'
	&op hl,&reg
	ex af,af'
	exx
	ret		;CHANGE_ME
	.ENDM
loadNNNNWith16 MACRO reg
	if ("&reg"=="sp")
		ld de,(registerSP)
	else
		exx
		push &reg
		exx
		pop de
	endif
	inc ix
	inc ix
	ld a,(currentRAMPage)
	ld c,a
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,c
	out (7),a
	ld (hl),e
	inc hl
	ld (hl),d
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
	.ENDM
load16FromNNNN MACRO reg
	inc ix
	inc ix
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	ld sp,speedstack
	inc iy
	inc iy
	ld a,81h
	out (7),a
	;HL is nnnn
	bit 7,h				;8
	jr nz,$_RAM	;12/7
	bit 6,h				;8
	jr z,$_0	;12/7
	set 7,h				;8
	res 6,h				;8
	ld a,(currompage)	;13
	out (7),a			;11
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,81h				;7
	out (7),a			;11
	if ("&reg"=="sp")
		ld (registerSP),de
	else
		push de
		exx
		pop &reg
		exx
	endif
	ret		;CHANGE_ME
$_0:
	set 7,h				;4
	ld a,(basepage)	;13
	out (7),a			;11
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,81h				;7
	out (7),a			;11
	if ("&reg"=="sp")
		ld (registerSP),de
	else
		push de
		exx
		pop &reg
		exx
	endif
	ret		;CHANGE_ME
$_RAM:
	ld a,(currentRAMPage)	;13
	out (7),a			;11
	ld e,(hl)
	inc hl
	ld d,(hl)
	ld a,81h				;7
	out (7),a			;11
	if ("&reg"=="sp")
		ld (registerSP),de
	else
		push de
		exx
		pop &reg
		exx
	endif
	ret		;CHANGE_ME
	.ENDM
Interrupt_Generated_Jump:
	jp Interrupt_Generated
Debug:
	nop
	ret
	nop
MainEmulation:
	ld hl,MainEmulation_Loop
	ld (speedstack),hl
MainEmulation_Loop:
	;Check for interrupt
	in a,(32h)
	dec a
 ifndef DEBUG
	jr z,Interrupt_Generated_Jump
 endif
 ifdef DEBUG
 	ld hl,(8700h)
	ld de,1
	add hl,de
	ld (8700h),hl
	ld hl,(8702h)
	ld de,0
	adc hl,de
	ld (8702h),hl
	ld a,(8702h)
	cp 4
	jr nz,DEBUG_2
	ld hl,(8700h)
	ld de,851
	or a
	sbc hl,de
	jr nz,DEBUG_2
	nop
DEBUG_2:
 	ld hl,(8710h)
	dec hl
	ld (8710h),hl
	ld a,h
	or l
	jr nz,DEBUG_1
	ld hl,1250
	ld (8710h),hl
	jp Interrupt_Generated
DEBUG_1:
 endif
	ld a,i
	out (7),a
	ld sp,iy
	pop hl
	inc ix
	inc iy
	ld a,81h
	out (7),a
	ld e,h			;next byte is in E
	ld h,42h >> 1
	add hl,hl
	ld sp,hl
	pop hl
	ld sp,speedstack
	jp (hl)
Fetch_Byte_PC:
	inc ix
	inc iy
	ld a,i
	out (7),a
	ld e,(iy-1)
	ld a,81h
	out (7),a
	ret
Fetch_Word_PC:
	inc ix
	inc ix
	inc iy
	inc iy
	ld a,i
	out (7),a
	ld l,(iy-2)
	ld h,(iy-1)
	ld a,81h
	out (7),a
	ret
Fetch_Byte_HL:
	push hl
	bit 7,h
	jr nz,Fetch_Byte_RAM
	;From flash
	bit 6,h
	jr z,Fetch_Byte_Page0
	;From arbitrary flash page
	ld a,(currompage)
	set 7,h
	res 6,h
	out (7),a
	ld e,(hl)
	ld a,81h
	out (7),a
	pop hl
	ret
Fetch_Byte_Page0:
	ld a,(basepage)
	set 7,h
	out (7),a
	ld e,(hl)
	ld a,81h
	out (7),a
	pop hl
	ret
Fetch_Byte_RAM:
	ld a,(currentRAMPage)
	out (7),a
	;RAM pages set up
	ld e,(hl)
	ld a,81h
	out (7),a
	pop hl
	ret
Write_Byte:
	;This will write byte C to HL
Write_Byte_RAM:
	ld a,(currentRAMPage)
	out (7),a
	;RAM pages set up
	ld (hl),c
	ld a,81h
	out (7),a
	ret
Opcode_F3:
	;di
	ld hl,emulatorflags
	res interruptsEnabled,(hl)
	ret		;CHANGE_ME
Opcode_FB:
	;ei
	ld hl,emulatorflags
	set interruptsEnabled,(hl)
	ret		;CHANGE_ME
Opcode_76:
	;halt
	dec ix
	dec iy
	ld hl,emulatorflags
	set haltActive,(hl)
	ret		;CHANGE_ME
Opcode_3F:
	;ccf
	opcodeA ccf
Opcode_37:
	;scf
	opcodeA scf
Opcode_27:
	;daa
	opcodeA daa
Opcode_2F:
	;cpl
	opcodeA cpl
Opcode_E1:
	;pop hl
	popReg hl
Opcode_D1:
	;pop de
	popReg de
Opcode_C1:
	;pop bc
	popReg bc
Opcode_F1:
	;pop af
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	pop af
	ex af,af'
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
Opcode_E5:
	;push hl
	pushReg hl
Opcode_D5:
	;push de
	pushReg de
Opcode_C5:
	;push bc
	pushReg bc
Opcode_F5:
	;push af
	ld sp,(registerSP)
	ld a,(currentRAMPage)
	out (7),a
	ex af,af'
	push af
	ex af,af'
	ld a,81h
	out (7),a
	ld (registerSP),sp
	ld sp,speedstack
	ret		;CHANGE_ME
Opcode_F9:
	;ld sp,hl
	exx
	ld (registerSP),hl
	exx
	ret		;CHANGE_ME
Opcode_78:
	;ld a,b
	load8R a,b
Opcode_79:
	;ld a,c
	load8R a,c
Opcode_7A:
	;ld a,d
	load8R a,d
Opcode_7B:
	;ld a,e
	load8R a,e
Opcode_7C:
	;ld a,h
	load8R a,h
Opcode_7D:
	;ld a,l
	load8R a,l
Opcode_7E:
	;ld a,(hl)
	loadRFrom16Reg a,h,l
Opcode_0A:
	;ld a,(bc)
	loadRFrom16Reg	a,b,c
Opcode_1A:
	;ld a,(de)
	loadRFrom16Reg a,d,e
Opcode_47:
	;ld b,a
	load8R b,a
Opcode_41:
	;ld b,c
	load8R b,c
Opcode_42:
	;ld b,d
	load8R b,d
Opcode_43:
	;ld b,e
	load8R b,e
Opcode_44:
	;ld b,h
	load8R b,h
Opcode_45:
	;ld b,l
	load8R b,l
Opcode_46:
	;ld b,(hl)
	loadRFrom16Reg b,h,l
Opcode_4F:
	;ld c,a
	load8R c,a
Opcode_48:
	;ld c,b
	load8R c,b
Opcode_4A:
	;ld c,d
	load8R c,d
Opcode_4B:
	;ld c,e
	load8R c,e
Opcode_4C:
	;ld c,h
	load8R c,h
Opcode_4D:
	;ld c,l
	load8R c,l
Opcode_4E:
	;ld c,(hl)
	loadRFrom16Reg c,h,l
Opcode_57:
	;ld d,a
	load8R d,a
Opcode_50:
	;ld d,b
	load8R d,b
Opcode_51:
	;ld d,c
	load8R d,c
Opcode_53:
	;ld d,e
	load8R d,e
Opcode_54:
	;ld d,h
	load8R d,h
Opcode_55:
	;ld d,l
	load8R d,l
Opcode_56:
	;ld d,(hl)
	loadRFrom16Reg d,h,l
Opcode_5F:
	;ld e,a
	load8R e,a
Opcode_58:
	;ld e,b
	load8R e,b
Opcode_59:
	;ld e,c
	load8R e,c
Opcode_5A:
	;ld e,d
	load8R e,d
Opcode_5C:
	;ld e,h
	load8R e,h
Opcode_5D:
	;ld e,l
	load8R e,l
Opcode_5E:
	;ld e,(hl)
	loadRFrom16Reg e,h,l
Opcode_67:
	;ld h,a
	load8R h,a
Opcode_60:
	;ld h,b
	load8R h,b
Opcode_61:
	;ld h,c
	load8R h,c
Opcode_62:
	;ld h,d
	load8R h,d
Opcode_63:
	;ld h,e
	load8R h,e
Opcode_65:
	;ld h,l
	load8R h,l
Opcode_66:
	;ld h,(hl)
	loadRFrom16Reg h,h,l
Opcode_6F:
	;ld l,a
	load8R l,a
Opcode_68:
	;ld l,b
	load8R l,b
Opcode_69:
	;ld l,c
	load8R l,c
Opcode_6A:
	;ld l,d
	load8R l,d
Opcode_6B:
	;ld l,e
	load8R l,e
Opcode_6C:
	;ld l,h
	load8R l,h
Opcode_6E:
	;ld l,(hl)
	loadRFrom16Reg l,h,l
Opcode_02:
	;ld (bc),a
	loadMemRegFromR bc,a
Opcode_12:
	;ld (de),a
	loadMemRegFromR de,a
Opcode_77:
	;ld (hl),a
	loadMemRegFromR hl,a
Opcode_70:
	;ld (hl),b
	loadMemRegFromR hl,b
Opcode_71:
	;ld (hl),c
	loadMemRegFromR hl,c
Opcode_72:
	;ld (hl),d
	loadMemRegFromR hl,d
Opcode_73:
	;ld (hl),e
	loadMemRegFromR hl,e
Opcode_74:
	;ld (hl),h
	loadMemRegFromR hl,h
Opcode_75:
	;ld (hl),l
	loadMemRegFromR hl,l
Opcode_36:
	;ld (hl),n
	inc ix
	inc iy
	ld a,(currentRAMPage)
	out (7),a
	ld a,e
	exx
	ld (hl),a
	exx
	ld a,81h
	out (7),a
	ret		;CHANGE_ME
Opcode_49:
Opcode_40:
Opcode_52:
Opcode_7F:
Opcode_00:
Opcode_5B:
Opcode_64:
Opcode_6D:
ED_4F:
	;ld a,a
	;ld b,b
	;ld c,c
	;ld d,d
	;ld e,e
	;ld h,h
	;ld l,l
	;ld r,a
	;nop
	ret
 INCLUDE "loadnn.asm"
 INCLUDE "opcode_dd.asm"
 INCLUDE "opcode_fd.asm"
 INCLUDE "opcode_ed.asm"
 INCLUDE "opcode_block.asm"
 INCLUDE "opcode_add.asm"
 INCLUDE "opcode_sub.asm"
 INCLUDE "opcode_logical.asm"
 INCLUDE "opcode_rotate.asm"
 INCLUDE "opcode_exec.asm"
